/*
 * $Id: ace620.prg,v 1.2 2004/04/14 21:10:40 andijahja Exp $
 */

/*
 * Harbour Project source code:
 * ACE32.DLL Import Library Definition Utility for Open-Watcom
 *
 * Copyright 2004 Andi Jahja <xharbour@cbn.net.id>
 * www - http://www.harbour-project.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA (or visit the web site http://www.gnu.org/).
 *
 * As a special exception, the Harbour Project gives permission for
 * additional uses of the text contained in its release of Harbour.
 *
 * The exception is that, if you link the Harbour libraries with other
 * files to produce an executable, this does not by itself cause the
 * resulting executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of
 * linking the Harbour library code into it.
 *
 * This exception does not however invalidate any other reasons why
 * the executable file might be covered by the GNU General Public License.
 *
 * This exception applies only to the code released by the Harbour
 * Project under the name Harbour.  If you copy code from other
 * Harbour Project or Free Software Foundation releases into a copy of
 * Harbour, as the General Public License permits, the exception does
 * not apply to the code that you add in this way.  To avoid misleading
 * anyone as to the status of such modified files, you must delete
 * this exception notice from them.
 *
 * If you write modifications of your own for Harbour, it is your choice
 * whether to permit this exception to apply to your modifications.
 * If you do not wish that, delete this exception notice.
 *
 */

/*
  ACE620.PRG
  This is a utility to create WatCom Import Library from ace32.dll as
  a ready-for-use ace32.lib for Watcom is not currently available.
  Please read comments on each sub-functions in this program file.

  How To Create ACE32.LIB for Open-Watcom 1.x:
  1. Compile this program
  2. Run ACE620.EXE in any directory ( file: ace32.def should be created )
  3. Run: LIB386 /out:ace32.lib /def:ace32.def
  4. Copy ace32.lib to your library folder
  5. Enjoy RDDADS with Watcom ;-)

  Andi Jahja

  2004-04-08 - First Release
  2004-04-10 - Updated to include ACE32.DLL version 7.0.0.5
*/
#define CRLF chr(13)+chr(10)
#xtranslate FWriteDEF( <x> ) => FWrite( h, <x> + CRLF )
#include "box.ch"
#include "inkey.ch"

//----------------------------------------------------------------------------//
PROCEDURE MAIN()

   LOCAL aWatCom
   LOCAL aACE
   LOCAL cInScr  := SaveScreen(0,0,MaxRow(),MaxCol())
   LOCAL n, oldColor := SetColor()
   LOCAL cFileName := "ace32.def"
   LOCAL h       := FCreate( cFileName )
   LOCAL aDef    := {}
   LOCAL cDef, __cDef, nAt, __aDef, cEXE
   LOCAL cCommand
   LOCAL nChoice
   LOCAL abox := { 5, 10, 8, 30 }
   LOCAL aversion := { " Version 6.20 ", " Version 7.0.0.5 " }

   CLEAR SCREEN
   DISPBOX( abox[1], abox[2], abox[3], abox[4], B_SINGLE + " ")
   nChoice := ACHOICE( abox[1]+1, abox[2]+1, abox[3]-1, abox[4]-1, aversion )

   IF nChoice == 0
      RETURN
   ELSEIF nChoice == 1
      aWatCom := DLLWatcom_60()
      aACE    := DLLAce_60()
   ELSEIF nChoice == 2
      aWatCom := DLLWatcom_70()
      aACE    := DLLAce_70()
   ENDIF

   CLEAR SCREEN

   IF( h < 0 )
      ALERT( "Error in creating file ...")
   ELSE
      OutStd( "Start job ..." + CRLF )
      FOR EACH cDef IN aWatCom
         __cDef := SubStr( cDef, 2 )
         nAt    := AT( "@", __cDef )
         __cDef := LEFT( __cDef, nAt - 1 )
         IF ( n := AScan( aACE, { |e| e[1] == __cDef }) ) > 0
            OutStd( "Creating definition for : " + __cDef + CRLF )
            AAdd( aDef, { space(5) + PADR( cDef,50 ) + aAce[n][2], strzero(val(strtran(aAce[n][2],"@")),4) } )
         ENDIF
      NEXT

      OutStd( "Finished ..." + CRLF )
      OutStd( "Sorting ..." + CRLF )
      ASort( aDef,,, { |a,b| a[2] < b[2] } )

      OutStd( "Writing file ..." + CRLF )
      FWriteDEF( "LIBRARY     ACE32.DLL" )
      FWriteDEF( "" )
      FWriteDEF( "EXPORTS" )

      FOR EACH __aDef IN aDef
         FWriteDEF( __aDef[1] )
      NEXT

      FClose( h )

      OutStd( "End of job ..." + CRLF )

      IF FILE( cFileName )
         IF ALERT( "ACE32.DEF created ("+ str(len(aDef),,,.T.) + " functions imported);Do you want to view the file ?", { " Yes ", " No "}, "W+/B" ) == 1
            SetColor( "W+/B" )
            View( cFileName )
            SetColor( oldColor )
         ENDIF
         cEXE := GetLibEXE()
         IF Empty( cEXE )
            ALERT( "To create ACE32.LIB please run:;LIB386 /out:ace32.lib /def:ace32.def;and place ACE32.LIB to library folder",{" Quit Now "},"W+/G" )
         ELSE
            IF ALERT( "Do you want to create ACE32.LIB now ?",{" Yes ", " No "},"N/BG*" ) == 1
               cCommand := cEXE + " /out:ace32.lib /def:ace32.def /machine:IX86"
               CLEAR SCREEN
               OutStd( cCommand + CRLF + CRLF )
               IF FILE( "ace32.lib" )
                  FErase( "ace32.lib" )
               ENDIF
               CreateLib( cCommand )
               IF FILE( "ace32.lib" )
                  Alert( "ACE32.LIB created!;Put the file into library folder", { " Quit Now " }, "W+/G" )
               ELSE
                  Alert( "Error in creating ACE32.LIB" )
               ENDIF
            ENDIF
         ENDIF
      ELSE
         Alert( "File creation error !" )
      ENDIF
   ENDIF

   RestScreen(0,0,MaxRow(),MaxCol(), cInScr )

   RETURN

//----------------------------------------------------------------------------//
STATIC FUNCTION DLLWATCOM_60()

   /*
   This is a list of all functions from ace32.dll version 6.20
   */

   LOCAL aFunc := {}

   AAdd( aFunc, "_AdsAddCustomKey@4"                 )
   AAdd( aFunc, "_AdsAppendRecord@4"                 )
   AAdd( aFunc, "_AdsApplicationExit@0"              )
   AAdd( aFunc, "_AdsAtBOF@8"                        )
   AAdd( aFunc, "_AdsAtEOF@8"                        )
   AAdd( aFunc, "_AdsBeginTransaction@4"             )
   AAdd( aFunc, "_AdsBinaryToFile@12"                )
   AAdd( aFunc, "_AdsCacheOpenTables@4"              )
   AAdd( aFunc, "_AdsClearAllScopes@4"               )
   AAdd( aFunc, "_AdsClearFilter@4"                  )
   AAdd( aFunc, "_AdsDisableEncryption@4"            )
   AAdd( aFunc, "_AdsClearProgressCallback@0"        )
   AAdd( aFunc, "_AdsClearRelation@4"                )
   AAdd( aFunc, "_AdsClearScope@8"                   )
   AAdd( aFunc, "_AdsCloseAllIndexes@4"              )
   AAdd( aFunc, "_AdsCloseAllTables@0"               )
   AAdd( aFunc, "_AdsCloseIndex@4"                   )
   AAdd( aFunc, "_AdsCloseTable@4"                   )
   AAdd( aFunc, "_AdsCommitTransaction@4"            )
   AAdd( aFunc, "_AdsConnect@8"                      )
   AAdd( aFunc, "_AdsContinue@8"                     )
   AAdd( aFunc, "_AdsCopyTable@12"                   )
   AAdd( aFunc, "_AdsCopyTableContents@12"           )
   AAdd( aFunc, "_AdsCopyTableStructure@8"           )
   AAdd( aFunc, "_AdsCreateIndex@32"                 )
   AAdd( aFunc, "_AdsCreateTable@40"                 )
   AAdd( aFunc, "_AdsDecryptTable@4"                 )
   AAdd( aFunc, "_AdsDeleteCustomKey@4"              )
   AAdd( aFunc, "_AdsDeleteIndex@4"                  )
   AAdd( aFunc, "_AdsDeleteRecord@4"                 )
   AAdd( aFunc, "_AdsDisconnect@4"                   )
   AAdd( aFunc, "_AdsEncryptTable@4"                 )
   AAdd( aFunc, "_AdsEvalLogicalExpr@12"             )
   AAdd( aFunc, "_AdsEvalNumericExpr@12"             )
   AAdd( aFunc, "_AdsEvalStringExpr@16"              )
   AAdd( aFunc, "_AdsEvalTestExpr@12"                )
   AAdd( aFunc, "_AdsExtractKey@12"                  )
   AAdd( aFunc, "_AdsFailedTransactionRecovery@4"    )
   AAdd( aFunc, "_AdsFileToBinary@16"                )
   AAdd( aFunc, "_AdsFindConnection@8"               )
   AAdd( aFunc, "_AdsGetAllIndexes@12"               )
   AAdd( aFunc, "_AdsGetAllLocks@12"                 )
   AAdd( aFunc, "_AdsGetAllTables@8"                 )
   AAdd( aFunc, "_AdsGetBinary@20"                   )
   AAdd( aFunc, "_AdsGetBinaryLength@12"             )
   AAdd( aFunc, "_AdsGetBookmark@8"                  )
   AAdd( aFunc, "_AdsGetCollationLang@8"             )
   AAdd( aFunc, "_AdsGetDate@16"                     )
   AAdd( aFunc, "_AdsGetDateFormat@8"                )
   AAdd( aFunc, "_AdsGetDecimals@4"                  )
   AAdd( aFunc, "_AdsGetDefault@8"                   )
   AAdd( aFunc, "_AdsGetDeleted@4"                   )
   AAdd( aFunc, "_AdsGetDouble@12"                   )
   AAdd( aFunc, "_AdsGetEpoch@4"                     )
   AAdd( aFunc, "_AdsGetErrorString@12"              )
   AAdd( aFunc, "_AdsGetExact@4"                     )
   AAdd( aFunc, "_AdsGetField@20"                    )
   AAdd( aFunc, "_AdsGetFieldDecimals@12"            )
   AAdd( aFunc, "_AdsGetFieldLength@12"              )
   AAdd( aFunc, "_AdsGetFieldName@16"                )
   AAdd( aFunc, "_AdsGetFieldNum@12"                 )
   AAdd( aFunc, "_AdsGetFieldOffset@12"              )
   AAdd( aFunc, "_AdsGetFieldType@12"                )
   AAdd( aFunc, "_AdsGetFilter@12"                   )
   AAdd( aFunc, "_AdsGetHandleLong@8"                )
   AAdd( aFunc, "_AdsGetIndexCondition@12"           )
   AAdd( aFunc, "_AdsGetIndexExpr@12"                )
   AAdd( aFunc, "_AdsGetIndexFilename@16"            )
   AAdd( aFunc, "_AdsGetIndexHandle@12"              )
   AAdd( aFunc, "_AdsGetIndexName@12"                )
   AAdd( aFunc, "_AdsGetKeyCount@12"                 )
   AAdd( aFunc, "_AdsGetKeyNum@12"                   )
   AAdd( aFunc, "_AdsGetLastError@12"                )
   AAdd( aFunc, "_AdsGetLogical@12"                  )
   AAdd( aFunc, "_AdsGetLong@12"                     )
   AAdd( aFunc, "_AdsGetMemoLength@12"               )
   AAdd( aFunc, "_AdsGetNumFields@8"                 )
   AAdd( aFunc, "_AdsGetNumIndexes@8"                )
   AAdd( aFunc, "_AdsGetNumLocks@8"                  )
   AAdd( aFunc, "_AdsGetNumOpenTables@4"             )
   AAdd( aFunc, "_AdsGetRecord@12"                   )
   AAdd( aFunc, "_AdsGetRecordCount@12"              )
   AAdd( aFunc, "_AdsGetRecordNum@12"                )
   AAdd( aFunc, "_AdsGetRecordLength@8"              )
   AAdd( aFunc, "_AdsGetRelKeyPos@8"                 )
   AAdd( aFunc, "_AdsGetScope@16"                    )
   AAdd( aFunc, "_AdsGetSearchPath@8"                )
   AAdd( aFunc, "_AdsGetServerName@12"               )
   AAdd( aFunc, "_AdsGetString@20"                   )
   AAdd( aFunc, "_AdsGetTableAlias@12"               )
   AAdd( aFunc, "_AdsGetTableCharType@8"             )
   AAdd( aFunc, "_AdsGetTableFilename@16"            )
   AAdd( aFunc, "_AdsGetTableHandle@8"               )
   AAdd( aFunc, "_AdsGetTableLockType@8"             )
   AAdd( aFunc, "_AdsGetTableMemoSize@8"             )
   AAdd( aFunc, "_AdsGetTableOpenOptions@8"          )
   AAdd( aFunc, "_AdsGetTableRights@8"               )
   AAdd( aFunc, "_AdsGetTableType@8"                 )
   AAdd( aFunc, "_AdsGetVersion@20"                  )
   AAdd( aFunc, "_AdsGotoBookmark@8"                 )
   AAdd( aFunc, "_AdsGotoBottom@4"                   )
   AAdd( aFunc, "_AdsGotoRecord@8"                   )
   AAdd( aFunc, "_AdsGotoTop@4"                      )
   AAdd( aFunc, "_AdsInTransaction@8"                )
   AAdd( aFunc, "_AdsIsEmpty@12"                     )
   AAdd( aFunc, "_AdsIsExprValid@12"                 )
   AAdd( aFunc, "_AdsIsFound@8"                      )
   AAdd( aFunc, "_AdsIsIndexCompound@8"              )
   AAdd( aFunc, "_AdsIsIndexCustom@8"                )
   AAdd( aFunc, "_AdsIsIndexDescending@8"            )
   AAdd( aFunc, "_AdsIsIndexUnique@8"                )
   AAdd( aFunc, "_AdsIsRecordEncrypted@8"            )
   AAdd( aFunc, "_AdsIsRecordLocked@12"              )
   AAdd( aFunc, "_AdsIsServerLoaded@8"               )
   AAdd( aFunc, "_AdsIsTableEncrypted@8"             )
   AAdd( aFunc, "_AdsIsTableLocked@8"                )
   AAdd( aFunc, "_AdsLocate@16"                      )
   AAdd( aFunc, "_AdsLockRecord@8"                   )
   AAdd( aFunc, "_AdsLockTable@4"                    )
   AAdd( aFunc, "_AdsOpenIndex@16"                   )
   AAdd( aFunc, "_AdsOpenTable@36"                   )
   AAdd( aFunc, "_AdsPackTable@4"                    )
   AAdd( aFunc, "_AdsRecallRecord@4"                 )
   AAdd( aFunc, "_AdsRegisterProgressCallback@4"     )
   AAdd( aFunc, "_AdsReindex@4"                      )
   AAdd( aFunc, "_AdsRollbackTransaction@4"          )
   AAdd( aFunc, "_AdsSeek@24"                        )
   AAdd( aFunc, "_AdsSeekLast@20"                    )
   AAdd( aFunc, "_AdsSetBinary@28"                   )
   AAdd( aFunc, "_AdsSetCollationLang@4"             )
   AAdd( aFunc, "_AdsSetDate@16"                     )
   AAdd( aFunc, "_AdsSetDateFormat@4"                )
   AAdd( aFunc, "_AdsSetDecimals@4"                  )
   AAdd( aFunc, "_AdsSetDefault@4"                   )
   AAdd( aFunc, "_AdsSetDouble@16"                   )
   AAdd( aFunc, "_AdsSetEmpty@8"                     )
   AAdd( aFunc, "_AdsSetEpoch@4"                     )
   AAdd( aFunc, "_AdsSetExact@4"                     )
   AAdd( aFunc, "_AdsSetField@16"                    )
   AAdd( aFunc, "_AdsSetFilter@8"                    )
   AAdd( aFunc, "_AdsSetHandleLong@8"                )
   AAdd( aFunc, "_AdsSetLogical@12"                  )
   AAdd( aFunc, "_AdsSetLong@12"                     )
   AAdd( aFunc, "_AdsEnableEncryption@8"             )
   AAdd( aFunc, "_AdsSetRecord@12"                   )
   AAdd( aFunc, "_AdsSetRelation@12"                 )
   AAdd( aFunc, "_AdsSetRelKeyPos@12"                )
   AAdd( aFunc, "_AdsSetScope@20"                    )
   AAdd( aFunc, "_AdsSetScopedRelation@12"           )
   AAdd( aFunc, "_AdsSetSearchPath@4"                )
   AAdd( aFunc, "_AdsSetString@16"                   )
   AAdd( aFunc, "_AdsShowDeleted@4"                  )
   AAdd( aFunc, "_AdsShowError@4"                    )
   AAdd( aFunc, "_AdsSkip@8"                         )
   AAdd( aFunc, "_AdsThreadExit@0"                   )
   AAdd( aFunc, "_AdsUnlockRecord@8"                 )
   AAdd( aFunc, "_AdsUnlockTable@4"                  )
   AAdd( aFunc, "_AdsWriteAllRecords@0"              )
   AAdd( aFunc, "_AdsWriteRecord@4"                  )
   AAdd( aFunc, "_AdsZapTable@4"                     )
   AAdd( aFunc, "_AdsGetColumnPermissions@12"        )
   AAdd( aFunc, "_AdsBuildKeyFromRecord@20"          )
   AAdd( aFunc, "_AdsCheckExistence@12"              )
   AAdd( aFunc, "_AdsConvertKeyToDouble@8"           )
   AAdd( aFunc, "_AdsDeleteTable@4"                  )
   AAdd( aFunc, "_AdsFindClose@8"                    )
   AAdd( aFunc, "_AdsFindFirstTable@20"              )
   AAdd( aFunc, "_AdsFindNextTable@16"               )
   AAdd( aFunc, "_AdsGetKeyType@8"                   )
   AAdd( aFunc, "_AdsGetNumSegments@8"               )
   AAdd( aFunc, "_AdsGetRecordPointer@8"             )
   AAdd( aFunc, "_AdsGetSegmentFieldname@16"         )
   AAdd( aFunc, "_AdsGetSegmentOffset@12"            )
   AAdd( aFunc, "_AdsGetIndexFlags@8"                )
   AAdd( aFunc, "_AdsGetNumActiveLinks@8"            )
   AAdd( aFunc, "_AdsMemCompare@24"                  )
   AAdd( aFunc, "_AdsDDCreateLink@24"                )
   AAdd( aFunc, "_AdsDDDropLink@12"                  )
   AAdd( aFunc, "_AdsConvertStringToJulian@12"       )
   AAdd( aFunc, "_AdsConvertJulianToString@16"       )
   AAdd( aFunc, "_AdsSetCollationSequence@4"         )
   AAdd( aFunc, "_AdsClearLastError@0"               )
   AAdd( aFunc, "_AdsDeleteFile@8"                   )
   AAdd( aFunc, "_AdsGetJulian@12"                   )
   AAdd( aFunc, "_AdsGetKeyLength@8"                 )
   AAdd( aFunc, "_AdsIsRecordDeleted@8"              )
   AAdd( aFunc, "_AdsNullTerminateStrings@4"         )
   AAdd( aFunc, "_AdsSetInternalError@12"            )
   AAdd( aFunc, "_AdsSetJulian@12"                   )
   AAdd( aFunc, "_AdsSetLastError@8"                 )
   AAdd( aFunc, "_AdsGetMemoDataType@12"             )
   AAdd( aFunc, "_AdsCancelUpdate@4"                 )
   AAdd( aFunc, "_AdsRefreshRecord@4"                )
   AAdd( aFunc, "_AdsSetTableCharType@8"             )
   AAdd( aFunc, "_AdsImageToHBitmap@12"              )
   AAdd( aFunc, "_AdsImageToClipboard@8"             )
   AAdd( aFunc, "_AdsSetServerType@4"                )
   AAdd( aFunc, "_AdsGetHandleType@8"                )
   AAdd( aFunc, "_AdsGetLastTableUpdate@12"          )
   AAdd( aFunc, "_AdsGetIndexHandleByOrder@12"       )
   AAdd( aFunc, "_AdsClearDefault@0"                 )
   AAdd( aFunc, "_AdsSetFieldRaw@16"                 )
   AAdd( aFunc, "_AdsGetIndexOrderByHandle@8"        )
   AAdd( aFunc, "_AdsGetTableConnection@8"           )
   AAdd( aFunc, "_AdsGetConnectionType@8"            )
   AAdd( aFunc, "_AdsCloneTable@8"                   )
   AAdd( aFunc, "_AdsSetBOFFlag@8"                   )
   AAdd( aFunc, "_ObsAdsEncryptBuffer@12"            )
   AAdd( aFunc, "_ObsAdsDecryptBuffer@12"            )
   AAdd( aFunc, "_AdsVerifyPassword@8"               )
   AAdd( aFunc, "_AdsDBFDateToString@8"              )
   AAdd( aFunc, "_AdsSetAOF@12"                      )
   AAdd( aFunc, "_AdsEvalAOF@12"                     )
   AAdd( aFunc, "_AdsClearAOF@4"                     )
   AAdd( aFunc, "_AdsRefreshAOF@4"                   )
   AAdd( aFunc, "_AdsActivateAOF@4"                  )
   AAdd( aFunc, "_AdsDeactivateAOF@4"                )
   AAdd( aFunc, "_AdsGetAOF@12"                      )
   AAdd( aFunc, "_AdsGetAOFOptLevel@16"              )
   AAdd( aFunc, "_AdsMgGetCommStats@12"              )
   AAdd( aFunc, "_AdsMgGetConfigInfo@20"             )
   AAdd( aFunc, "_AdsMgGetActivityInfo@12"           )
   AAdd( aFunc, "_AdsMgGetInstallInfo@12"            )
   AAdd( aFunc, "_AdsMgResetCommStats@4"             )
   AAdd( aFunc, "_AdsMgDumpInternalTables@4"         )
   AAdd( aFunc, "_AdsMgGetUserNames@20"              )
   AAdd( aFunc, "_AdsMgGetOpenTables@24"             )
   AAdd( aFunc, "_AdsMgGetOpenIndexes@28"            )
   AAdd( aFunc, "_AdsMgGetLocks@28"                  )
   AAdd( aFunc, "_AdsMgGetServerType@8"              )
   AAdd( aFunc, "_AdsMgKillUser@12"                  )
   AAdd( aFunc, "_AdsMgGetWorkerThreadActivity@16"   )
   AAdd( aFunc, "_AdsMgGetLockOwner@24"              )
   AAdd( aFunc, "_AdsIsRecordInAOF@12"               )
   AAdd( aFunc, "_AdsMgConnect@16"                   )
   AAdd( aFunc, "_AdsMgDisconnect@4"                 )
   AAdd( aFunc, "_AdsGetLibraryVersion@4"            )
   AAdd( aFunc, "_AdsCacheRecords@8"                 )
   AAdd( aFunc, "_AdsExtractPathPart@16"             )
   AAdd( aFunc, "_AdsSetTime@16"                     )
   AAdd( aFunc, "_AdsGetTime@16"                     )
   AAdd( aFunc, "_AdsSetShort@12"                    )
   AAdd( aFunc, "_AdsGetShort@12"                    )
   AAdd( aFunc, "_AdsConvertTable@16"                )
   AAdd( aFunc, "_AdsSetMilliseconds@12"             )
   AAdd( aFunc, "_AdsGetMilliseconds@12"             )
   AAdd( aFunc, "_AdsLookupKey@20"                   )
   AAdd( aFunc, "_AdsInitRawKey@4"                   )
   AAdd( aFunc, "_AdsBuildRawKey@12"                 )
   AAdd( aFunc, "_AdsSetExact22@8"                   )
   AAdd( aFunc, "_AdsGetExact22@8"                   )
   AAdd( aFunc, "_AdsExpressionLongToShort@16"       )
   AAdd( aFunc, "_AdsExpressionShortToLong@16"       )
   AAdd( aFunc, "_AdsCustomizeAOF@16"                )
   AAdd( aFunc, "_AdsIsSegmentDescending@12"         )
   AAdd( aFunc, "_AdsConvertStringToMilliseconds@12" )
   AAdd( aFunc, "_AdsConvertMillisecondsToString@12" )
   AAdd( aFunc, "_AdsCloseSQLStatement@4"            )
   AAdd( aFunc, "_AdsCreateSQLStatement@8"           )
   AAdd( aFunc, "_AdsExecuteSQL@8"                   )
   AAdd( aFunc, "_AdsExecuteSQLDirect@12"            )
   AAdd( aFunc, "_AdsGetIndexHandleByExpr@16"        )
   AAdd( aFunc, "_AdsPrepareSQL@8"                   )
   AAdd( aFunc, "_AdsSetTimeStamp@16"                )
   AAdd( aFunc, "_AdsStmtSetTableCharType@8"         )
   AAdd( aFunc, "_AdsStmtSetTableLockType@8"         )
   AAdd( aFunc, "_AdsStmtSetTableReadOnly@8"         )
   AAdd( aFunc, "_AdsStmtSetTableRights@8"           )
   AAdd( aFunc, "_AdsStmtSetTableType@8"             )
   AAdd( aFunc, "_AdsClearSQLParams@4"               )
   AAdd( aFunc, "_AdsGetTableHandle25@12"            )
   AAdd( aFunc, "_AdsSetTimeStampRaw@16"             )
   AAdd( aFunc, "_AdsSetCursorAOF@12"                )
   AAdd( aFunc, "_AdsClearCursorAOF@4"               )
   AAdd( aFunc, "_AdsCacheOpenCursors@4"             )
   AAdd( aFunc, "_AdsStmtConstrainUpdates@8"         )
   AAdd( aFunc, "_AdsEncryptRecord@4"                )
   AAdd( aFunc, "_AdsDecryptRecord@4"                )
   AAdd( aFunc, "_AdsIsEncryptionEnabled@8"          )
   AAdd( aFunc, "_AdsClearRecordBuffer@12"           )
   AAdd( aFunc, "_AdsIsRecordVisible@8"              )
   AAdd( aFunc, "_AdsParseExpr@16"                   )
   AAdd( aFunc, "_AdsEvalExpr@16"                    )
   AAdd( aFunc, "_AdsFreeExpr@8"                     )
   AAdd( aFunc, "_AdsFindConnection25@8"             )
   AAdd( aFunc, "_AdsPerformRI@12"                   )
   AAdd( aFunc, "_AdsStmtEnableEncryption@8"         )
   AAdd( aFunc, "_AdsStmtDisableEncryption@4"        )
   AAdd( aFunc, "_AdsStmtSetTablePassword@12"        )
   AAdd( aFunc, "_AdsStmtClearTablePasswords@4"      )
   AAdd( aFunc, "_AdsGetServerTime@24"               )
   AAdd( aFunc, "_AdsIsIndexExprValid@12"            )
   AAdd( aFunc, "_AdsRegisterSQLAbortFunc@4"         )
   AAdd( aFunc, "_AdsClearSQLAbortFunc@0"            )
   AAdd( aFunc, "_AdsSqlPeekStatement@8"             )
   AAdd( aFunc, "_AdsIsIndexUserDefined@8"           )
   AAdd( aFunc, "_AdsRegisterUDF@12"                 )
   AAdd( aFunc, "_AdsConnect26@12"                   )
   AAdd( aFunc, "_AdsStepIndexKey@16"                )
   AAdd( aFunc, "_AdsPrepareSQLNow@16"               )
   AAdd( aFunc, "_AdsGetNumParams@8"                 )
   AAdd( aFunc, "_AdsEcho@12"                        )
   AAdd( aFunc, "_AdsDDCreate@16"                    )
   AAdd( aFunc, "_AdsDDClose@4"                      )
   AAdd( aFunc, "_AdsDDOpen@12"                      )
   AAdd( aFunc, "_AdsDDGetDatabaseProperty@16"       )
   AAdd( aFunc, "_AdsDDSetDatabaseProperty@16"       )
   AAdd( aFunc, "_AdsDDAddTable@28"                  )
   AAdd( aFunc, "_AdsDDRemoveTable@12"               )
   AAdd( aFunc, "_AdsConnect60@24"                   )
   AAdd( aFunc, "_AdsDDGetTableProperty@20"          )
   AAdd( aFunc, "_AdsDDSetTableProperty@28"          )
   AAdd( aFunc, "_AdsDDCreateRefIntegrity@36"        )
   AAdd( aFunc, "_AdsDDFindFirstObject@24"           )
   AAdd( aFunc, "_AdsDDFindNextObject@16"            )
   AAdd( aFunc, "_AdsDDFindClose@8"                  )
   AAdd( aFunc, "_AdsRestructureTable@40"            )
   AAdd( aFunc, "_AdsReadRecords@12"                 )
   AAdd( aFunc, "_AdsReadRecordNumbers@24"           )
   AAdd( aFunc, "_AdsMergeAOF@4"                     )
   AAdd( aFunc, "_AdsSetupRI@16"                     )
   AAdd( aFunc, "_AdsGetFieldRaw@16"                 )
   AAdd( aFunc, "_AdsDisableLocalConnections@0"      )
   AAdd( aFunc, "_AdsLockRecordImplicitly@8"         )
   AAdd( aFunc, "_AdsDDSetFieldProperty@32"          )
   AAdd( aFunc, "_AdsDDGetFieldProperty@24"          )
   AAdd( aFunc, "_AdsDDAddIndexFile@16"              )
   AAdd( aFunc, "_AdsDDRemoveRefIntegrity@8"         )
   AAdd( aFunc, "_AdsDDGetIndexFileProperty@24"      )
   AAdd( aFunc, "_AdsGetLastAutoinc@8"               )
   AAdd( aFunc, "_AdsDDGetRefIntegrityProperty@20"   )
   AAdd( aFunc, "_AdsDDRemoveIndexFile@16"           )
   AAdd( aFunc, "_AdsDDDeleteIndex@12"               )
   AAdd( aFunc, "_AdsDDAddView@16"                   )
   AAdd( aFunc, "_AdsDDRemoveView@8"                 )
   AAdd( aFunc, "_AdsDDGetViewProperty@20"           )
   AAdd( aFunc, "_AdsGetBaseFieldNum@12"             )
   AAdd( aFunc, "_AdsGetBaseFieldName@16"            )
   AAdd( aFunc, "_AdsGetCursorAOF@12"                )
   AAdd( aFunc, "_AdsGetSQLStatementHandle@8"        )
   AAdd( aFunc, "_AdsGetSQLStatement@12"             )
   AAdd( aFunc, "_AdsRefreshView@4"                  )
   AAdd( aFunc, "_AdsGetSegmentFieldNumbers@12"      )
   AAdd( aFunc, "_AdsDDCreateUser@20"                )
   AAdd( aFunc, "_AdsDDAddUserToGroup@12"            )
   AAdd( aFunc, "_AdsDDDeleteUser@8"                 )
   AAdd( aFunc, "_AdsDDRemoveUserFromGroup@12"       )
   AAdd( aFunc, "_AdsDDCreateUserGroup@12"           )
   AAdd( aFunc, "_AdsDDDeleteUserGroup@8"            )
   AAdd( aFunc, "_AdsDDAddProcedure@32"              )
   AAdd( aFunc, "_AdsDDRemoveProcedure@8"            )
   AAdd( aFunc, "_AdsDDGetProcedureProperty@20"      )
   AAdd( aFunc, "_AdsDDExecuteProcedure@16"          )
   AAdd( aFunc, "_AdsDDGetIndexProperty@24"          )
   AAdd( aFunc, "_AdsDDGetUserProperty@20"           )
   AAdd( aFunc, "_AdsSetFlushFlag@8"                 )
   AAdd( aFunc, "_AdsGetRILookupInfo@12"             )
   AAdd( aFunc, "_AdsSetPacketSize@8"                )
   AAdd( aFunc, "_AdsVerifyRI@8"                     )
   AAdd( aFunc, "_AdsAddToAOF@16"                    )
   AAdd( aFunc, "_AdsDDSetUserProperty@20"           )
   AAdd( aFunc, "_AdsDDSetObjectAccessRights@16"     )
   AAdd( aFunc, "_AdsDDGetTableOpenOptions@48"       )
   AAdd( aFunc, "_AdsDDGetUserGroupProperty@20"      )
   AAdd( aFunc, "_AdsDDSetUserGroupProperty@20"      )
   AAdd( aFunc, "_AdsGetBookmark60@12"               )
   AAdd( aFunc, "_AdsGetBookmarkLength@8"            )
   AAdd( aFunc, "_AdsCompareBookmarks@12"            )
   AAdd( aFunc, "_AdsGotoBookmark60@8"               )
   AAdd( aFunc, "_AdsDDVerifyUserRights@12"          )
   AAdd( aFunc, "_AdsSetDateFormat60@8"              )
   AAdd( aFunc, "_AdsFlushFileBuffers@4"             )
   AAdd( aFunc, "_AdsDDDeployDatabase@32"            )
   AAdd( aFunc, "_AdsCreateIndex61@36"               )
   AAdd( aFunc, "_AdsReindex61@8"                    )
   AAdd( aFunc, "_AdsGetIndexPageSize@8"             )
   AAdd( aFunc, "_AdsStmtReadAllColumns@8"           )
   AAdd( aFunc, "_AdsDDAutoCreateTable@8"            )
   AAdd( aFunc, "_AdsDDAutoCreateIndex@12"           )
   AAdd( aFunc, "_AdsGetDateFormat60@12"             )
   AAdd( aFunc, "_AdsGetROWIDPrefix@12"              )
   AAdd( aFunc, "_AdsRegisterCallbackFunction@8"     )
   AAdd( aFunc, "_AdsClearCallbackFunction@0"        )
   AAdd( aFunc, "_AdsGetSQLStmtParams@4"             )
   AAdd( aFunc, "_AdsSetBaseTableAccess@8"           )
   AAdd( aFunc, "_AdsDDGetPermissions@28"            )
   AAdd( aFunc, "_AdsDDGrantPermission@24"           )
   AAdd( aFunc, "_AdsDDRevokePermission@24"          )
   AAdd( aFunc, "_AdsCopyTableTop@12"                )
   AAdd( aFunc, "_AdsGetNullRecord@12"               )
   AAdd( aFunc, "_AdsDDCreateRefIntegrity62@44"      )
   AAdd( aFunc, "_AdsGetActiveLinkInfo@16"           )
   AAdd( aFunc, "_AdsDDGetLinkProperty@20"           )
   AAdd( aFunc, "_AdsSetProperty@12"                 )
   AAdd( aFunc, "_AdsVerifySQL@8"                    )
   AAdd( aFunc, "_AdsFindFirstTable62@28"            )
   AAdd( aFunc, "_AdsFindNextTable62@24"             )
   AAdd( aFunc, "_AdsEnableUniqueEnforcement@4"      )
   AAdd( aFunc, "_AdsDisableUniqueEnforcement@4"     )
   AAdd( aFunc, "_AdsEnableRI@4"                     )
   AAdd( aFunc, "_AdsDisableRI@4"                    )
   AAdd( aFunc, "_AdsRemoveSQLComments@4"            )
   AAdd( aFunc, "_AdsEnableAutoIncEnforcement@4"     )
   AAdd( aFunc, "_AdsDisableAutoIncEnforcement@4"    )
   RETURN aFunc

//----------------------------------------------------------------------------//
STATIC FUNCTION DLLWATCOM_70()

   /*
   This is a list of all functions from ace32.dll version 7.0.0.2
   */

   LOCAL aFunc := {}

   AAdd( aFunc, "_AdsAddCustomKey@4"                 )
   AAdd( aFunc, "_AdsAppendRecord@4"                 )
   AAdd( aFunc, "_AdsApplicationExit@0"              )
   AAdd( aFunc, "_AdsAtBOF@8"                        )
   AAdd( aFunc, "_AdsAtEOF@8"                        )
   AAdd( aFunc, "_AdsBeginTransaction@4"             )
   AAdd( aFunc, "_AdsBinaryToFile@12"                )
   AAdd( aFunc, "_AdsCacheOpenTables@4"              )
   AAdd( aFunc, "_AdsClearAllScopes@4"               )
   AAdd( aFunc, "_AdsClearFilter@4"                  )
   AAdd( aFunc, "_AdsDisableEncryption@4"            )
   AAdd( aFunc, "_AdsClearProgressCallback@0"        )
   AAdd( aFunc, "_AdsClearRelation@4"                )
   AAdd( aFunc, "_AdsClearScope@8"                   )
   AAdd( aFunc, "_AdsCloseAllIndexes@4"              )
   AAdd( aFunc, "_AdsCloseAllTables@0"               )
   AAdd( aFunc, "_AdsCloseIndex@4"                   )
   AAdd( aFunc, "_AdsCloseTable@4"                   )
   AAdd( aFunc, "_AdsCommitTransaction@4"            )
   AAdd( aFunc, "_AdsConnect@8"                      )
   AAdd( aFunc, "_AdsContinue@8"                     )
   AAdd( aFunc, "_AdsCopyTable@12"                   )
   AAdd( aFunc, "_AdsCopyTableContents@12"           )
   AAdd( aFunc, "_AdsCopyTableStructure@8"           )
   AAdd( aFunc, "_AdsCreateIndex@32"                 )
   AAdd( aFunc, "_AdsCreateTable@40"                 )
   AAdd( aFunc, "_AdsDecryptTable@4"                 )
   AAdd( aFunc, "_AdsDeleteCustomKey@4"              )
   AAdd( aFunc, "_AdsDeleteIndex@4"                  )
   AAdd( aFunc, "_AdsDeleteRecord@4"                 )
   AAdd( aFunc, "_AdsDisconnect@4"                   )
   AAdd( aFunc, "_AdsEncryptTable@4"                 )
   AAdd( aFunc, "_AdsEvalLogicalExpr@12"             )
   AAdd( aFunc, "_AdsEvalNumericExpr@12"             )
   AAdd( aFunc, "_AdsEvalStringExpr@16"              )
   AAdd( aFunc, "_AdsEvalTestExpr@12"                )
   AAdd( aFunc, "_AdsExtractKey@12"                  )
   AAdd( aFunc, "_AdsFailedTransactionRecovery@4"    )
   AAdd( aFunc, "_AdsFileToBinary@16"                )
   AAdd( aFunc, "_AdsFindConnection@8"               )
   AAdd( aFunc, "_AdsGetAllIndexes@12"               )
   AAdd( aFunc, "_AdsGetAllLocks@12"                 )
   AAdd( aFunc, "_AdsGetAllTables@8"                 )
   AAdd( aFunc, "_AdsGetBinary@20"                   )
   AAdd( aFunc, "_AdsGetBinaryLength@12"             )
   AAdd( aFunc, "_AdsGetBookmark@8"                  )
   AAdd( aFunc, "_AdsGetCollationLang@8"             )
   AAdd( aFunc, "_AdsGetDate@16"                     )
   AAdd( aFunc, "_AdsGetDateFormat@8"                )
   AAdd( aFunc, "_AdsGetDecimals@4"                  )
   AAdd( aFunc, "_AdsGetDefault@8"                   )
   AAdd( aFunc, "_AdsGetDeleted@4"                   )
   AAdd( aFunc, "_AdsGetDouble@12"                   )
   AAdd( aFunc, "_AdsGetEpoch@4"                     )
   AAdd( aFunc, "_AdsGetErrorString@12"              )
   AAdd( aFunc, "_AdsGetExact@4"                     )
   AAdd( aFunc, "_AdsGetField@20"                    )
   AAdd( aFunc, "_AdsGetFieldDecimals@12"            )
   AAdd( aFunc, "_AdsGetFieldLength@12"              )
   AAdd( aFunc, "_AdsGetFieldName@16"                )
   AAdd( aFunc, "_AdsGetFieldNum@12"                 )
   AAdd( aFunc, "_AdsGetFieldOffset@12"              )
   AAdd( aFunc, "_AdsGetFieldType@12"                )
   AAdd( aFunc, "_AdsGetFilter@12"                   )
   AAdd( aFunc, "_AdsGetHandleLong@8"                )
   AAdd( aFunc, "_AdsGetIndexCondition@12"           )
   AAdd( aFunc, "_AdsGetIndexExpr@12"                )
   AAdd( aFunc, "_AdsGetIndexFilename@16"            )
   AAdd( aFunc, "_AdsGetIndexHandle@12"              )
   AAdd( aFunc, "_AdsGetIndexName@12"                )
   AAdd( aFunc, "_AdsGetKeyCount@12"                 )
   AAdd( aFunc, "_AdsGetKeyNum@12"                   )
   AAdd( aFunc, "_AdsGetLastError@12"                )
   AAdd( aFunc, "_AdsGetLogical@12"                  )
   AAdd( aFunc, "_AdsGetLong@12"                     )
   AAdd( aFunc, "_AdsGetMemoLength@12"               )
   AAdd( aFunc, "_AdsGetNumFields@8"                 )
   AAdd( aFunc, "_AdsGetNumIndexes@8"                )
   AAdd( aFunc, "_AdsGetNumLocks@8"                  )
   AAdd( aFunc, "_AdsGetNumOpenTables@4"             )
   AAdd( aFunc, "_AdsGetRecord@12"                   )
   AAdd( aFunc, "_AdsGetRecordCount@12"              )
   AAdd( aFunc, "_AdsGetRecordNum@12"                )
   AAdd( aFunc, "_AdsGetRecordLength@8"              )
   AAdd( aFunc, "_AdsGetRelKeyPos@8"                 )
   AAdd( aFunc, "_AdsGetScope@16"                    )
   AAdd( aFunc, "_AdsGetSearchPath@8"                )
   AAdd( aFunc, "_AdsGetServerName@12"               )
   AAdd( aFunc, "_AdsGetString@20"                   )
   AAdd( aFunc, "_AdsGetTableAlias@12"               )
   AAdd( aFunc, "_AdsGetTableCharType@8"             )
   AAdd( aFunc, "_AdsGetTableFilename@16"            )
   AAdd( aFunc, "_AdsGetTableHandle@8"               )
   AAdd( aFunc, "_AdsGetTableLockType@8"             )
   AAdd( aFunc, "_AdsGetTableMemoSize@8"             )
   AAdd( aFunc, "_AdsGetTableOpenOptions@8"          )
   AAdd( aFunc, "_AdsGetTableRights@8"               )
   AAdd( aFunc, "_AdsGetTableType@8"                 )
   AAdd( aFunc, "_AdsGetVersion@20"                  )
   AAdd( aFunc, "_AdsGotoBookmark@8"                 )
   AAdd( aFunc, "_AdsGotoBottom@4"                   )
   AAdd( aFunc, "_AdsGotoRecord@8"                   )
   AAdd( aFunc, "_AdsGotoTop@4"                      )
   AAdd( aFunc, "_AdsInTransaction@8"                )
   AAdd( aFunc, "_AdsIsEmpty@12"                     )
   AAdd( aFunc, "_AdsIsExprValid@12"                 )
   AAdd( aFunc, "_AdsIsFound@8"                      )
   AAdd( aFunc, "_AdsIsIndexCompound@8"              )
   AAdd( aFunc, "_AdsIsIndexCustom@8"                )
   AAdd( aFunc, "_AdsIsIndexDescending@8"            )
   AAdd( aFunc, "_AdsIsIndexUnique@8"                )
   AAdd( aFunc, "_AdsIsRecordEncrypted@8"            )
   AAdd( aFunc, "_AdsIsRecordLocked@12"              )
   AAdd( aFunc, "_AdsIsServerLoaded@8"               )
   AAdd( aFunc, "_AdsIsTableEncrypted@8"             )
   AAdd( aFunc, "_AdsIsTableLocked@8"                )
   AAdd( aFunc, "_AdsLocate@16"                      )
   AAdd( aFunc, "_AdsLockRecord@8"                   )
   AAdd( aFunc, "_AdsLockTable@4"                    )
   AAdd( aFunc, "_AdsOpenIndex@16"                   )
   AAdd( aFunc, "_AdsOpenTable@36"                   )
   AAdd( aFunc, "_AdsPackTable@4"                    )
   AAdd( aFunc, "_AdsRecallRecord@4"                 )
   AAdd( aFunc, "_AdsRegisterProgressCallback@4"     )
   AAdd( aFunc, "_AdsReindex@4"                      )
   AAdd( aFunc, "_AdsRollbackTransaction@4"          )
   AAdd( aFunc, "_AdsSeek@24"                        )
   AAdd( aFunc, "_AdsSeekLast@20"                    )
   AAdd( aFunc, "_AdsSetBinary@28"                   )
   AAdd( aFunc, "_AdsSetCollationLang@4"             )
   AAdd( aFunc, "_AdsSetDate@16"                     )
   AAdd( aFunc, "_AdsSetDateFormat@4"                )
   AAdd( aFunc, "_AdsSetDecimals@4"                  )
   AAdd( aFunc, "_AdsSetDefault@4"                   )
   AAdd( aFunc, "_AdsSetDouble@16"                   )
   AAdd( aFunc, "_AdsSetEmpty@8"                     )
   AAdd( aFunc, "_AdsSetEpoch@4"                     )
   AAdd( aFunc, "_AdsSetExact@4"                     )
   AAdd( aFunc, "_AdsSetField@16"                    )
   AAdd( aFunc, "_AdsSetFilter@8"                    )
   AAdd( aFunc, "_AdsSetHandleLong@8"                )
   AAdd( aFunc, "_AdsSetLogical@12"                  )
   AAdd( aFunc, "_AdsSetLong@12"                     )
   AAdd( aFunc, "_AdsEnableEncryption@8"             )
   AAdd( aFunc, "_AdsSetRecord@12"                   )
   AAdd( aFunc, "_AdsSetRelation@12"                 )
   AAdd( aFunc, "_AdsSetRelKeyPos@12"                )
   AAdd( aFunc, "_AdsSetScope@20"                    )
   AAdd( aFunc, "_AdsSetScopedRelation@12"           )
   AAdd( aFunc, "_AdsSetSearchPath@4"                )
   AAdd( aFunc, "_AdsSetString@16"                   )
   AAdd( aFunc, "_AdsShowDeleted@4"                  )
   AAdd( aFunc, "_AdsShowError@4"                    )
   AAdd( aFunc, "_AdsSkip@8"                         )
   AAdd( aFunc, "_AdsThreadExit@0"                   )
   AAdd( aFunc, "_AdsUnlockRecord@8"                 )
   AAdd( aFunc, "_AdsUnlockTable@4"                  )
   AAdd( aFunc, "_AdsWriteAllRecords@0"              )
   AAdd( aFunc, "_AdsWriteRecord@4"                  )
   AAdd( aFunc, "_AdsZapTable@4"                     )
   AAdd( aFunc, "_AdsGetColumnPermissions@12"        )
   AAdd( aFunc, "_AdsBuildKeyFromRecord@20"          )
   AAdd( aFunc, "_AdsCheckExistence@12"              )
   AAdd( aFunc, "_AdsConvertKeyToDouble@8"           )
   AAdd( aFunc, "_AdsDeleteTable@4"                  )
   AAdd( aFunc, "_AdsFindClose@8"                    )
   AAdd( aFunc, "_AdsFindFirstTable@20"              )
   AAdd( aFunc, "_AdsFindNextTable@16"               )
   AAdd( aFunc, "_AdsGetKeyType@8"                   )
   AAdd( aFunc, "_AdsGetNumSegments@8"               )
   AAdd( aFunc, "_AdsGetRecordPointer@8"             )
   AAdd( aFunc, "_AdsGetSegmentFieldname@16"         )
   AAdd( aFunc, "_AdsGetSegmentOffset@12"            )
   AAdd( aFunc, "_AdsGetIndexFlags@8"                )
   AAdd( aFunc, "_AdsGetNumActiveLinks@8"            )
   AAdd( aFunc, "_AdsMemCompare@24"                  )
   AAdd( aFunc, "_AdsDDCreateLink@24"                )
   AAdd( aFunc, "_AdsDDDropLink@12"                  )
   AAdd( aFunc, "_AdsConvertStringToJulian@12"       )
   AAdd( aFunc, "_AdsConvertJulianToString@16"       )
   AAdd( aFunc, "_AdsSetCollationSequence@4"         )
   AAdd( aFunc, "_AdsClearLastError@0"               )
   AAdd( aFunc, "_AdsDeleteFile@8"                   )
   AAdd( aFunc, "_AdsGetJulian@12"                   )
   AAdd( aFunc, "_AdsGetKeyLength@8"                 )
   AAdd( aFunc, "_AdsIsRecordDeleted@8"              )
   AAdd( aFunc, "_AdsNullTerminateStrings@4"         )
   AAdd( aFunc, "_AdsSetInternalError@12"            )
   AAdd( aFunc, "_AdsSetJulian@12"                   )
   AAdd( aFunc, "_AdsSetLastError@8"                 )
   AAdd( aFunc, "_AdsGetMemoDataType@12"             )
   AAdd( aFunc, "_AdsCancelUpdate@4"                 )
   AAdd( aFunc, "_AdsRefreshRecord@4"                )
   AAdd( aFunc, "_AdsSetTableCharType@8"             )
   AAdd( aFunc, "_AdsImageToHBitmap@12"              )
   AAdd( aFunc, "_AdsImageToClipboard@8"             )
   AAdd( aFunc, "_AdsSetServerType@4"                )
   AAdd( aFunc, "_AdsGetHandleType@8"                )
   AAdd( aFunc, "_AdsGetLastTableUpdate@12"          )
   AAdd( aFunc, "_AdsGetIndexHandleByOrder@12"       )
   AAdd( aFunc, "_AdsClearDefault@0"                 )
   AAdd( aFunc, "_AdsSetFieldRaw@16"                 )
   AAdd( aFunc, "_AdsGetIndexOrderByHandle@8"        )
   AAdd( aFunc, "_AdsGetTableConnection@8"           )
   AAdd( aFunc, "_AdsGetConnectionType@8"            )
   AAdd( aFunc, "_AdsCloneTable@8"                   )
   AAdd( aFunc, "_AdsSetBOFFlag@8"                   )
   AAdd( aFunc, "_AdsVerifyPassword@8"               )
   AAdd( aFunc, "_AdsDBFDateToString@8"              )
   AAdd( aFunc, "_AdsSetAOF@12"                      )
   AAdd( aFunc, "_AdsEvalAOF@12"                     )
   AAdd( aFunc, "_AdsClearAOF@4"                     )
   AAdd( aFunc, "_AdsRefreshAOF@4"                   )
   AAdd( aFunc, "_AdsActivateAOF@4"                  )
   AAdd( aFunc, "_AdsDeactivateAOF@4"                )
   AAdd( aFunc, "_AdsGetAOF@12"                      )
   AAdd( aFunc, "_AdsGetAOFOptLevel@16"              )
   AAdd( aFunc, "_AdsMgGetCommStats@12"              )
   AAdd( aFunc, "_AdsMgGetConfigInfo@20"             )
   AAdd( aFunc, "_AdsMgGetActivityInfo@12"           )
   AAdd( aFunc, "_AdsMgGetInstallInfo@12"            )
   AAdd( aFunc, "_AdsMgResetCommStats@4"             )
   AAdd( aFunc, "_AdsMgDumpInternalTables@4"         )
   AAdd( aFunc, "_AdsMgGetUserNames@20"              )
   AAdd( aFunc, "_AdsMgGetOpenTables@24"             )
   AAdd( aFunc, "_AdsMgGetOpenIndexes@28"            )
   AAdd( aFunc, "_AdsMgGetLocks@28"                  )
   AAdd( aFunc, "_AdsMgGetServerType@8"              )
   AAdd( aFunc, "_AdsMgKillUser@12"                  )
   AAdd( aFunc, "_AdsMgGetWorkerThreadActivity@16"   )
   AAdd( aFunc, "_AdsMgGetLockOwner@24"              )
   AAdd( aFunc, "_AdsIsRecordInAOF@12"               )
   AAdd( aFunc, "_AdsMgConnect@16"                   )
   AAdd( aFunc, "_AdsMgDisconnect@4"                 )
   AAdd( aFunc, "_AdsGetLibraryVersion@4"            )
   AAdd( aFunc, "_AdsCacheRecords@8"                 )
   AAdd( aFunc, "_AdsExtractPathPart@16"             )
   AAdd( aFunc, "_AdsSetTime@16"                     )
   AAdd( aFunc, "_AdsGetTime@16"                     )
   AAdd( aFunc, "_AdsSetShort@12"                    )
   AAdd( aFunc, "_AdsGetShort@12"                    )
   AAdd( aFunc, "_AdsConvertTable@16"                )
   AAdd( aFunc, "_AdsSetMilliseconds@12"             )
   AAdd( aFunc, "_AdsGetMilliseconds@12"             )
   AAdd( aFunc, "_AdsLookupKey@20"                   )
   AAdd( aFunc, "_AdsInitRawKey@4"                   )
   AAdd( aFunc, "_AdsBuildRawKey@12"                 )
   AAdd( aFunc, "_AdsSetExact22@8"                   )
   AAdd( aFunc, "_AdsGetExact22@8"                   )
   AAdd( aFunc, "_AdsExpressionLongToShort@16"       )
   AAdd( aFunc, "_AdsExpressionShortToLong@16"       )
   AAdd( aFunc, "_AdsCustomizeAOF@16"                )
   AAdd( aFunc, "_AdsIsSegmentDescending@12"         )
   AAdd( aFunc, "_AdsConvertStringToMilliseconds@12" )
   AAdd( aFunc, "_AdsConvertMillisecondsToString@12" )
   AAdd( aFunc, "_AdsCloseSQLStatement@4"            )
   AAdd( aFunc, "_AdsCreateSQLStatement@8"           )
   AAdd( aFunc, "_AdsExecuteSQL@8"                   )
   AAdd( aFunc, "_AdsExecuteSQLDirect@12"            )
   AAdd( aFunc, "_AdsGetIndexHandleByExpr@16"        )
   AAdd( aFunc, "_AdsPrepareSQL@8"                   )
   AAdd( aFunc, "_AdsSetTimeStamp@16"                )
   AAdd( aFunc, "_AdsStmtSetTableCharType@8"         )
   AAdd( aFunc, "_AdsStmtSetTableLockType@8"         )
   AAdd( aFunc, "_AdsStmtSetTableReadOnly@8"         )
   AAdd( aFunc, "_AdsStmtSetTableRights@8"           )
   AAdd( aFunc, "_AdsStmtSetTableType@8"             )
   AAdd( aFunc, "_AdsClearSQLParams@4"               )
   AAdd( aFunc, "_AdsGetTableHandle25@12"            )
   AAdd( aFunc, "_AdsSetTimeStampRaw@16"             )
   AAdd( aFunc, "_AdsSetCursorAOF@12"                )
   AAdd( aFunc, "_AdsClearCursorAOF@4"               )
   AAdd( aFunc, "_AdsCacheOpenCursors@4"             )
   AAdd( aFunc, "_AdsStmtConstrainUpdates@8"         )
   AAdd( aFunc, "_AdsEncryptRecord@4"                )
   AAdd( aFunc, "_AdsDecryptRecord@4"                )
   AAdd( aFunc, "_AdsIsEncryptionEnabled@8"          )
   AAdd( aFunc, "_AdsClearRecordBuffer@12"           )
   AAdd( aFunc, "_AdsIsRecordVisible@8"              )
   AAdd( aFunc, "_AdsParseExpr@16"                   )
   AAdd( aFunc, "_AdsEvalExpr@16"                    )
   AAdd( aFunc, "_AdsFreeExpr@8"                     )
   AAdd( aFunc, "_AdsFindConnection25@8"             )
   AAdd( aFunc, "_AdsPerformRI@12"                   )
   AAdd( aFunc, "_AdsStmtEnableEncryption@8"         )
   AAdd( aFunc, "_AdsStmtDisableEncryption@4"        )
   AAdd( aFunc, "_AdsStmtSetTablePassword@12"        )
   AAdd( aFunc, "_AdsStmtClearTablePasswords@4"      )
   AAdd( aFunc, "_AdsGetServerTime@24"               )
   AAdd( aFunc, "_AdsIsIndexExprValid@12"            )
   AAdd( aFunc, "_AdsRegisterSQLAbortFunc@4"         )
   AAdd( aFunc, "_AdsClearSQLAbortFunc@0"            )
   AAdd( aFunc, "_AdsSqlPeekStatement@8"             )
   AAdd( aFunc, "_AdsIsIndexUserDefined@8"           )
   AAdd( aFunc, "_AdsRegisterUDF@12"                 )
   AAdd( aFunc, "_AdsConnect26@12"                   )
   AAdd( aFunc, "_AdsStepIndexKey@16"                )
   AAdd( aFunc, "_AdsPrepareSQLNow@16"               )
   AAdd( aFunc, "_AdsGetNumParams@8"                 )
   AAdd( aFunc, "_AdsEcho@12"                        )
   AAdd( aFunc, "_AdsDDCreate@16"                    )
   AAdd( aFunc, "_AdsDDClose@4"                      )
   AAdd( aFunc, "_AdsDDOpen@12"                      )
   AAdd( aFunc, "_AdsDDGetDatabaseProperty@16"       )
   AAdd( aFunc, "_AdsDDSetDatabaseProperty@16"       )
   AAdd( aFunc, "_AdsDDAddTable@28"                  )
   AAdd( aFunc, "_AdsDDRemoveTable@12"               )
   AAdd( aFunc, "_AdsConnect60@24"                   )
   AAdd( aFunc, "_AdsDDGetTableProperty@20"          )
   AAdd( aFunc, "_AdsDDSetTableProperty@28"          )
   AAdd( aFunc, "_AdsDDCreateRefIntegrity@36"        )
   AAdd( aFunc, "_AdsDDFindFirstObject@24"           )
   AAdd( aFunc, "_AdsDDFindNextObject@16"            )
   AAdd( aFunc, "_AdsDDFindClose@8"                  )
   AAdd( aFunc, "_AdsRestructureTable@40"            )
   AAdd( aFunc, "_AdsReadRecords@12"                 )
   AAdd( aFunc, "_AdsReadRecordNumbers@24"           )
   AAdd( aFunc, "_AdsMergeAOF@4"                     )
   AAdd( aFunc, "_AdsSetupRI@16"                     )
   AAdd( aFunc, "_AdsGetFieldRaw@16"                 )
   AAdd( aFunc, "_AdsDisableLocalConnections@0"      )
   AAdd( aFunc, "_AdsLockRecordImplicitly@8"         )
   AAdd( aFunc, "_AdsDDSetFieldProperty@32"          )
   AAdd( aFunc, "_AdsDDGetFieldProperty@24"          )
   AAdd( aFunc, "_AdsDDAddIndexFile@16"              )
   AAdd( aFunc, "_AdsDDRemoveRefIntegrity@8"         )
   AAdd( aFunc, "_AdsDDGetIndexFileProperty@24"      )
   AAdd( aFunc, "_AdsGetLastAutoinc@8"               )
   AAdd( aFunc, "_AdsDDGetRefIntegrityProperty@20"   )
   AAdd( aFunc, "_AdsDDRemoveIndexFile@16"           )
   AAdd( aFunc, "_AdsDDDeleteIndex@12"               )
   AAdd( aFunc, "_AdsDDAddView@16"                   )
   AAdd( aFunc, "_AdsDDRemoveView@8"                 )
   AAdd( aFunc, "_AdsDDGetViewProperty@20"           )
   AAdd( aFunc, "_AdsGetBaseFieldNum@12"             )
   AAdd( aFunc, "_AdsGetBaseFieldName@16"            )
   AAdd( aFunc, "_AdsGetCursorAOF@12"                )
   AAdd( aFunc, "_AdsGetSQLStatementHandle@8"        )
   AAdd( aFunc, "_AdsGetSQLStatement@12"             )
   AAdd( aFunc, "_AdsRefreshView@4"                  )
   AAdd( aFunc, "_AdsGetSegmentFieldNumbers@12"      )
   AAdd( aFunc, "_AdsDDCreateUser@20"                )
   AAdd( aFunc, "_AdsDDAddUserToGroup@12"            )
   AAdd( aFunc, "_AdsDDDeleteUser@8"                 )
   AAdd( aFunc, "_AdsDDRemoveUserFromGroup@12"       )
   AAdd( aFunc, "_AdsDDCreateUserGroup@12"           )
   AAdd( aFunc, "_AdsDDDeleteUserGroup@8"            )
   AAdd( aFunc, "_AdsDDAddProcedure@32"              )
   AAdd( aFunc, "_AdsDDRemoveProcedure@8"            )
   AAdd( aFunc, "_AdsDDGetProcedureProperty@20"      )
   AAdd( aFunc, "_AdsDDExecuteProcedure@20"          )
   AAdd( aFunc, "_AdsDDGetIndexProperty@24"          )
   AAdd( aFunc, "_AdsDDGetUserProperty@20"           )
   AAdd( aFunc, "_AdsSetFlushFlag@8"                 )
   AAdd( aFunc, "_AdsGetRILookupInfo@12"             )
   AAdd( aFunc, "_AdsSetPacketSize@8"                )
   AAdd( aFunc, "_AdsVerifyRI@8"                     )
   AAdd( aFunc, "_AdsAddToAOF@16"                    )
   AAdd( aFunc, "_AdsDDSetUserProperty@20"           )
   AAdd( aFunc, "_AdsDDSetObjectAccessRights@16"     )
   AAdd( aFunc, "_AdsDDGetTableOpenOptions@56"       )
   AAdd( aFunc, "_AdsDDGetUserGroupProperty@20"      )
   AAdd( aFunc, "_AdsDDSetUserGroupProperty@20"      )
   AAdd( aFunc, "_AdsGetBookmark60@12"               )
   AAdd( aFunc, "_AdsGetBookmarkLength@8"            )
   AAdd( aFunc, "_AdsCompareBookmarks@12"            )
   AAdd( aFunc, "_AdsGotoBookmark60@8"               )
   AAdd( aFunc, "_AdsDDVerifyUserRights@12"          )
   AAdd( aFunc, "_AdsSetDateFormat60@8"              )
   AAdd( aFunc, "_AdsFlushFileBuffers@4"             )
   AAdd( aFunc, "_AdsDDDeployDatabase@32"            )
   AAdd( aFunc, "_AdsCreateIndex61@36"               )
   AAdd( aFunc, "_AdsReindex61@8"                    )
   AAdd( aFunc, "_AdsGetIndexPageSize@8"             )
   AAdd( aFunc, "_AdsStmtReadAllColumns@8"           )
   AAdd( aFunc, "_AdsDDAutoCreateTable@8"            )
   AAdd( aFunc, "_AdsDDAutoCreateIndex@12"           )
   AAdd( aFunc, "_AdsGetDateFormat60@12"             )
   AAdd( aFunc, "_AdsGetROWIDPrefix@12"              )
   AAdd( aFunc, "_AdsRegisterCallbackFunction@8"     )
   AAdd( aFunc, "_AdsClearCallbackFunction@0"        )
   AAdd( aFunc, "_AdsGetSQLStmtParams@4"             )
   AAdd( aFunc, "_AdsSetBaseTableAccess@8"           )
   AAdd( aFunc, "_AdsDDGetPermissions@28"            )
   AAdd( aFunc, "_AdsDDGrantPermission@24"           )
   AAdd( aFunc, "_AdsDDRevokePermission@24"          )
   AAdd( aFunc, "_AdsCopyTableTop@12"                )
   AAdd( aFunc, "_AdsGetNullRecord@12"               )
   AAdd( aFunc, "_AdsDDCreateRefIntegrity62@44"      )
   AAdd( aFunc, "_AdsGetActiveLinkInfo@16"           )
   AAdd( aFunc, "_AdsDDGetLinkProperty@20"           )
   AAdd( aFunc, "_AdsSetProperty@12"                 )
   AAdd( aFunc, "_AdsVerifySQL@8"                    )
   AAdd( aFunc, "_AdsFindFirstTable62@28"            )
   AAdd( aFunc, "_AdsFindNextTable62@24"             )
   AAdd( aFunc, "_AdsEnableUniqueEnforcement@4"      )
   AAdd( aFunc, "_AdsDisableUniqueEnforcement@4"     )
   AAdd( aFunc, "_AdsEnableRI@4"                     )
   AAdd( aFunc, "_AdsDisableRI@4"                    )
   AAdd( aFunc, "_AdsRemoveSQLComments@4"            )
   AAdd( aFunc, "_AdsEnableAutoIncEnforcement@4"     )
   AAdd( aFunc, "_AdsDisableAutoIncEnforcement@4"    )
   AAdd( aFunc, "_AdsDDCreateTrigger@44"             )
   AAdd( aFunc, "_AdsDDRemoveTrigger@8"              )
   AAdd( aFunc, "_AdsDDGetTriggerProperty@20"        )
   AAdd( aFunc, "_AdsGotoBOF@4"                      )
   AAdd( aFunc, "_AdsGetMoney@12"                    )
   AAdd( aFunc, "_AdsSetMoney@16"                    )
   AAdd( aFunc, "_AdsSetLongLong@16"                 )
   AAdd( aFunc, "_AdsGetLongLong@12"                 )
   AAdd( aFunc, "_AdsCreateFTSIndex@72"              )
   AAdd( aFunc, "_AdsReindexFTS@8"                   )
   AAdd( aFunc, "_AdsGetNumFTSIndexes@8"             )
   AAdd( aFunc, "_AdsGetFTSIndexes@12"               )
   AAdd( aFunc, "_AdsGetConnectionPath@12"           )
   AAdd( aFunc, "_AdsDDCreateASA@20"                 )
   AAdd( aFunc, "_AdsInitTokenBuffer@8"              )
   AAdd( aFunc, "_AdsMakeNameUnique@16"              )
   AAdd( aFunc, "_AdsFreeTokenBuffer@8"              )
   AAdd( aFunc, "_AdsGetFTSIndexInfo@52"             )
   AAdd( aFunc, "_AdsGetTableWAN@8"                  )
   AAdd( aFunc, "_AdsPullTrigger@32"                 )
   AAdd( aFunc, "_AdsCreateMemTable@24"              )
   AAdd( aFunc, "_AdsGetFTSScore@28"                 )
   AAdd( aFunc, "_AdsGetKeyColumn@12"                )
   AAdd( aFunc, "_AdsResetConnection@4"              )
   AAdd( aFunc, "_AdsIsIndexFTS@8"                   )
   AAdd( aFunc, "_AdsRecallAllRecords@4"             )
   AAdd( aFunc, "_AdsConvertDateToJulian@16"         )
   AAdd( aFunc, "_AdsCloseCachedTables@4"            )
   AAdd( aFunc, "_AdsGetConnectionProperty@16"       )

   RETURN aFunc

//----------------------------------------------------------------------------//
STATIC FUNCTION DLLACE_60()

   /*
   This ordinal table is based on ace32.dll version 6.20
   This table should be updated when using other version of ace32.dll
   It will be much better to create a new sub-function, say DLLACE_70 for
   version 7.0 rather than overwriting this function.
   */

   LOCAL aEntry := {}

   AAdd( aEntry, { "AdsActivateAOF"                    , "@220"   } )
   AAdd( aEntry, { "AdsAddCustomKey"                   , "@1"     } )
   AAdd( aEntry, { "AdsAddToAOF"                       , "@366"   } )
   AAdd( aEntry, { "AdsAppendRecord"                   , "@2"     } )
   AAdd( aEntry, { "AdsApplicationExit"                , "@3"     } )
   AAdd( aEntry, { "AdsAtBOF"                          , "@4"     } )
   AAdd( aEntry, { "AdsAtEOF"                          , "@5"     } )
   AAdd( aEntry, { "AdsBeginTransaction"               , "@6"     } )
   AAdd( aEntry, { "AdsBinaryToFile"                   , "@7"     } )
   AAdd( aEntry, { "AdsBuildKeyFromRecord"             , "@166"   } )
   AAdd( aEntry, { "AdsBuildRawKey"                    , "@253"   } )
   AAdd( aEntry, { "AdsCacheOpenCursors"               , "@279"   } )
   AAdd( aEntry, { "AdsCacheOpenTables"                , "@8"     } )
   AAdd( aEntry, { "AdsCacheRecords"                   , "@242"   } )
   AAdd( aEntry, { "AdsCancelUpdate"                   , "@196"   } )
   AAdd( aEntry, { "AdsCheckExistence"                 , "@167"   } )
   AAdd( aEntry, { "AdsClearAOF"                       , "@218"   } )
   AAdd( aEntry, { "AdsClearAllScopes"                 , "@9"     } )
   AAdd( aEntry, { "AdsClearCallbackFunction"          , "@389"   } )
   AAdd( aEntry, { "AdsClearCursorAOF"                 , "@278"   } )
   AAdd( aEntry, { "AdsClearDefault"                   , "@205"   } )
   AAdd( aEntry, { "AdsClearFilter"                    , "@10"    } )
   AAdd( aEntry, { "AdsClearLastError"                 , "@186"   } )
   AAdd( aEntry, { "AdsClearProgressCallback"          , "@13"    } )
   AAdd( aEntry, { "AdsClearRecordBuffer"              , "@284"   } )
   AAdd( aEntry, { "AdsClearRelation"                  , "@14"    } )
   AAdd( aEntry, { "AdsClearSQLAbortFunc"              , "@298"   } )
   AAdd( aEntry, { "AdsClearSQLParams"                 , "@274"   } )
   AAdd( aEntry, { "AdsClearScope"                     , "@15"    } )
   AAdd( aEntry, { "AdsCloneTable"                     , "@210"   } )
   AAdd( aEntry, { "AdsCloseAllIndexes"                , "@16"    } )
   AAdd( aEntry, { "AdsCloseAllTables"                 , "@17"    } )
   AAdd( aEntry, { "AdsCloseIndex"                     , "@18"    } )
   AAdd( aEntry, { "AdsCloseSQLStatement"              , "@262"   } )
   AAdd( aEntry, { "AdsCloseTable"                     , "@19"    } )
   AAdd( aEntry, { "AdsCommitTransaction"              , "@20"    } )
   AAdd( aEntry, { "AdsCompareBookmarks"               , "@374"   } )
   AAdd( aEntry, { "AdsConnect"                        , "@21"    } )
   AAdd( aEntry, { "AdsConnect26"                      , "@302"   } )
   AAdd( aEntry, { "AdsConnect60"                      , "@315"   } )
   AAdd( aEntry, { "AdsContinue"                       , "@22"    } )
   AAdd( aEntry, { "AdsConvertJulianToString"          , "@184"   } )
   AAdd( aEntry, { "AdsConvertKeyToDouble"             , "@168"   } )
   AAdd( aEntry, { "AdsConvertMillisecondsToString"    , "@261"   } )
   AAdd( aEntry, { "AdsConvertStringToJulian"          , "@183"   } )
   AAdd( aEntry, { "AdsConvertStringToMilliseconds"    , "@260"   } )
   AAdd( aEntry, { "AdsConvertTable"                   , "@248"   } )
   AAdd( aEntry, { "AdsCopyTable"                      , "@23"    } )
   AAdd( aEntry, { "AdsCopyTableContents"              , "@24"    } )
   AAdd( aEntry, { "AdsCopyTableStructure"             , "@25"    } )
   AAdd( aEntry, { "AdsCopyTableTop"                   , "@395"   } )
   AAdd( aEntry, { "AdsCreateIndex"                    , "@26"    } )
   AAdd( aEntry, { "AdsCreateIndex61"                  , "@380"   } )
   AAdd( aEntry, { "AdsCreateSQLStatement"             , "@263"   } )
   AAdd( aEntry, { "AdsCreateTable"                    , "@27"    } )
   AAdd( aEntry, { "AdsCustomizeAOF"                   , "@258"   } )
   AAdd( aEntry, { "AdsDBFDateToString"                , "@215"   } )
   AAdd( aEntry, { "AdsDDAddIndexFile"                 , "@333"   } )
   AAdd( aEntry, { "AdsDDAddProcedure"                 , "@356"   } )
   AAdd( aEntry, { "AdsDDAddTable"                     , "@313"   } )
   AAdd( aEntry, { "AdsDDAddUserToGroup"               , "@351"   } )
   AAdd( aEntry, { "AdsDDAddView"                      , "@340"   } )
   AAdd( aEntry, { "AdsDDAutoCreateIndex"              , "@385"   } )
   AAdd( aEntry, { "AdsDDAutoCreateTable"              , "@384"   } )
   AAdd( aEntry, { "AdsDDClose"                        , "@309"   } )
   AAdd( aEntry, { "AdsDDCreate"                       , "@308"   } )
   AAdd( aEntry, { "AdsDDCreateLink"                   , "@181"   } )
   AAdd( aEntry, { "AdsDDCreateRefIntegrity"           , "@318"   } )
   AAdd( aEntry, { "AdsDDCreateRefIntegrity62"         , "@397"   } )
   AAdd( aEntry, { "AdsDDCreateUser"                   , "@350"   } )
   AAdd( aEntry, { "AdsDDCreateUserGroup"              , "@354"   } )
   AAdd( aEntry, { "AdsDDDeleteIndex"                  , "@339"   } )
   AAdd( aEntry, { "AdsDDDeleteUser"                   , "@352"   } )
   AAdd( aEntry, { "AdsDDDeleteUserGroup"              , "@355"   } )
   AAdd( aEntry, { "AdsDDDeployDatabase"               , "@379"   } )
   AAdd( aEntry, { "AdsDDDropLink"                     , "@182"   } )
   AAdd( aEntry, { "AdsDDExecuteProcedure"             , "@359"   } )
   AAdd( aEntry, { "AdsDDFindClose"                    , "@321"   } )
   AAdd( aEntry, { "AdsDDFindFirstObject"              , "@319"   } )
   AAdd( aEntry, { "AdsDDFindNextObject"               , "@320"   } )
   AAdd( aEntry, { "AdsDDGetDatabaseProperty"          , "@311"   } )
   AAdd( aEntry, { "AdsDDGetFieldProperty"             , "@332"   } )
   AAdd( aEntry, { "AdsDDGetIndexFileProperty"         , "@335"   } )
   AAdd( aEntry, { "AdsDDGetIndexProperty"             , "@360"   } )
   AAdd( aEntry, { "AdsDDGetLinkProperty"              , "@399"   } )
   AAdd( aEntry, { "AdsDDGetPermissions"               , "@392"   } )
   AAdd( aEntry, { "AdsDDGetProcedureProperty"         , "@358"   } )
   AAdd( aEntry, { "AdsDDGetRefIntegrityProperty"      , "@337"   } )
   AAdd( aEntry, { "AdsDDGetTableOpenOptions"          , "@369"   } )
   AAdd( aEntry, { "AdsDDGetTableProperty"             , "@316"   } )
   AAdd( aEntry, { "AdsDDGetUserGroupProperty"         , "@370"   } )
   AAdd( aEntry, { "AdsDDGetUserProperty"              , "@361"   } )
   AAdd( aEntry, { "AdsDDGetViewProperty"              , "@342"   } )
   AAdd( aEntry, { "AdsDDGrantPermission"              , "@393"   } )
   AAdd( aEntry, { "AdsDDOpen"                         , "@310"   } )
   AAdd( aEntry, { "AdsDDRemoveIndexFile"              , "@338"   } )
   AAdd( aEntry, { "AdsDDRemoveProcedure"              , "@357"   } )
   AAdd( aEntry, { "AdsDDRemoveRefIntegrity"           , "@334"   } )
   AAdd( aEntry, { "AdsDDRemoveTable"                  , "@314"   } )
   AAdd( aEntry, { "AdsDDRemoveUserFromGroup"          , "@353"   } )
   AAdd( aEntry, { "AdsDDRemoveView"                   , "@341"   } )
   AAdd( aEntry, { "AdsDDRevokePermission"             , "@394"   } )
   AAdd( aEntry, { "AdsDDSetDatabaseProperty"          , "@312"   } )
   AAdd( aEntry, { "AdsDDSetFieldProperty"             , "@331"   } )
   AAdd( aEntry, { "AdsDDSetObjectAccessRights"        , "@368"   } )
   AAdd( aEntry, { "AdsDDSetTableProperty"             , "@317"   } )
   AAdd( aEntry, { "AdsDDSetUserGroupProperty"         , "@371"   } )
   AAdd( aEntry, { "AdsDDSetUserProperty"              , "@367"   } )
   AAdd( aEntry, { "AdsDDVerifyUserRights"             , "@376"   } )
   AAdd( aEntry, { "AdsDeactivateAOF"                  , "@221"   } )
   AAdd( aEntry, { "AdsDecryptRecord"                  , "@282"   } )
   AAdd( aEntry, { "AdsDecryptTable"                   , "@28"    } )
   AAdd( aEntry, { "AdsDeleteCustomKey"                , "@29"    } )
   AAdd( aEntry, { "AdsDeleteFile"                     , "@187"   } )
   AAdd( aEntry, { "AdsDeleteIndex"                    , "@30"    } )
   AAdd( aEntry, { "AdsDeleteRecord"                   , "@31"    } )
   AAdd( aEntry, { "AdsDeleteTable"                    , "@169"   } )
   AAdd( aEntry, { "AdsDisableAutoIncEnforcement"      , "@410"   } )
   AAdd( aEntry, { "AdsDisableEncryption"              , "@12"    } )
   AAdd( aEntry, { "AdsDisableLocalConnections"        , "@329"   } )
   AAdd( aEntry, { "AdsDisableRI"                      , "@407"   } )
   AAdd( aEntry, { "AdsDisableUniqueEnforcement"       , "@405"   } )
   AAdd( aEntry, { "AdsDisconnect"                     , "@32"    } )
   AAdd( aEntry, { "AdsEcho"                           , "@307"   } )
   AAdd( aEntry, { "AdsEnableAutoIncEnforcement"       , "@409"   } )
   AAdd( aEntry, { "AdsEnableEncryption"               , "@148"   } )
   AAdd( aEntry, { "AdsEnableRI"                       , "@406"   } )
   AAdd( aEntry, { "AdsEnableUniqueEnforcement"        , "@404"   } )
   AAdd( aEntry, { "AdsEncryptRecord"                  , "@281"   } )
   AAdd( aEntry, { "AdsEncryptTable"                   , "@33"    } )
   AAdd( aEntry, { "AdsEvalAOF"                        , "@217"   } )
   AAdd( aEntry, { "AdsEvalExpr"                       , "@287"   } )
   AAdd( aEntry, { "AdsEvalLogicalExpr"                , "@34"    } )
   AAdd( aEntry, { "AdsEvalNumericExpr"                , "@35"    } )
   AAdd( aEntry, { "AdsEvalStringExpr"                 , "@36"    } )
   AAdd( aEntry, { "AdsEvalTestExpr"                   , "@37"    } )
   AAdd( aEntry, { "AdsExecuteSQL"                     , "@264"   } )
   AAdd( aEntry, { "AdsExecuteSQLDirect"               , "@265"   } )
   AAdd( aEntry, { "AdsExpressionLongToShort"          , "@256"   } )
   AAdd( aEntry, { "AdsExpressionShortToLong"          , "@257"   } )
   AAdd( aEntry, { "AdsExtractKey"                     , "@38"    } )
   AAdd( aEntry, { "AdsExtractPathPart"                , "@243"   } )
   AAdd( aEntry, { "AdsFailedTransactionRecovery"      , "@39"    } )
   AAdd( aEntry, { "AdsFileToBinary"                   , "@40"    } )
   AAdd( aEntry, { "AdsFindClose"                      , "@170"   } )
   AAdd( aEntry, { "AdsFindConnection"                 , "@41"    } )
   AAdd( aEntry, { "AdsFindConnection25"               , "@289"   } )
   AAdd( aEntry, { "AdsFindFirstTable"                 , "@171"   } )
   AAdd( aEntry, { "AdsFindFirstTable62"               , "@402"   } )
   AAdd( aEntry, { "AdsFindNextTable"                  , "@172"   } )
   AAdd( aEntry, { "AdsFindNextTable62"                , "@403"   } )
   AAdd( aEntry, { "AdsFlushFileBuffers"               , "@378"   } )
   AAdd( aEntry, { "AdsFreeExpr"                       , "@288"   } )
   AAdd( aEntry, { "AdsGetAOF"                         , "@222"   } )
   AAdd( aEntry, { "AdsGetAOFOptLevel"                 , "@223"   } )
   AAdd( aEntry, { "AdsGetActiveLinkInfo"              , "@398"   } )
   AAdd( aEntry, { "AdsGetAllIndexes"                  , "@42"    } )
   AAdd( aEntry, { "AdsGetAllLocks"                    , "@43"    } )
   AAdd( aEntry, { "AdsGetAllTables"                   , "@44"    } )
   AAdd( aEntry, { "AdsGetBaseFieldName"               , "@344"   } )
   AAdd( aEntry, { "AdsGetBaseFieldNum"                , "@343"   } )
   AAdd( aEntry, { "AdsGetBinary"                      , "@45"    } )
   AAdd( aEntry, { "AdsGetBinaryLength"                , "@46"    } )
   AAdd( aEntry, { "AdsGetBookmark"                    , "@47"    } )
   AAdd( aEntry, { "AdsGetBookmark60"                  , "@372"   } )
   AAdd( aEntry, { "AdsGetBookmarkLength"              , "@373"   } )
   AAdd( aEntry, { "AdsGetCollationLang"               , "@48"    } )
   AAdd( aEntry, { "AdsGetColumnPermissions"           , "@165"   } )
   AAdd( aEntry, { "AdsGetConnectionType"              , "@209"   } )
   AAdd( aEntry, { "AdsGetCursorAOF"                   , "@345"   } )
   AAdd( aEntry, { "AdsGetDate"                        , "@49"    } )
   AAdd( aEntry, { "AdsGetDateFormat"                  , "@50"    } )
   AAdd( aEntry, { "AdsGetDateFormat60"                , "@386"   } )
   AAdd( aEntry, { "AdsGetDecimals"                    , "@51"    } )
   AAdd( aEntry, { "AdsGetDefault"                     , "@52"    } )
   AAdd( aEntry, { "AdsGetDeleted"                     , "@53"    } )
   AAdd( aEntry, { "AdsGetDouble"                      , "@54"    } )
   AAdd( aEntry, { "AdsGetEpoch"                       , "@55"    } )
   AAdd( aEntry, { "AdsGetErrorString"                 , "@56"    } )
   AAdd( aEntry, { "AdsGetExact"                       , "@57"    } )
   AAdd( aEntry, { "AdsGetExact22"                     , "@255"   } )
   AAdd( aEntry, { "AdsGetField"                       , "@58"    } )
   AAdd( aEntry, { "AdsGetFieldDecimals"               , "@59"    } )
   AAdd( aEntry, { "AdsGetFieldLength"                 , "@60"    } )
   AAdd( aEntry, { "AdsGetFieldName"                   , "@61"    } )
   AAdd( aEntry, { "AdsGetFieldNum"                    , "@62"    } )
   AAdd( aEntry, { "AdsGetFieldOffset"                 , "@63"    } )
   AAdd( aEntry, { "AdsGetFieldRaw"                    , "@328"   } )
   AAdd( aEntry, { "AdsGetFieldType"                   , "@64"    } )
   AAdd( aEntry, { "AdsGetFilter"                      , "@65"    } )
   AAdd( aEntry, { "AdsGetHandleLong"                  , "@66"    } )
   AAdd( aEntry, { "AdsGetHandleType"                  , "@202"   } )
   AAdd( aEntry, { "AdsGetIndexCondition"              , "@67"    } )
   AAdd( aEntry, { "AdsGetIndexExpr"                   , "@68"    } )
   AAdd( aEntry, { "AdsGetIndexFilename"               , "@69"    } )
   AAdd( aEntry, { "AdsGetIndexFlags"                  , "@178"   } )
   AAdd( aEntry, { "AdsGetIndexHandle"                 , "@70"    } )
   AAdd( aEntry, { "AdsGetIndexHandleByExpr"           , "@266"   } )
   AAdd( aEntry, { "AdsGetIndexHandleByOrder"          , "@204"   } )
   AAdd( aEntry, { "AdsGetIndexName"                   , "@71"    } )
   AAdd( aEntry, { "AdsGetIndexOrderByHandle"          , "@207"   } )
   AAdd( aEntry, { "AdsGetIndexPageSize"               , "@382"   } )
   AAdd( aEntry, { "AdsGetJulian"                      , "@188"   } )
   AAdd( aEntry, { "AdsGetKeyCount"                    , "@72"    } )
   AAdd( aEntry, { "AdsGetKeyLength"                   , "@189"   } )
   AAdd( aEntry, { "AdsGetKeyNum"                      , "@73"    } )
   AAdd( aEntry, { "AdsGetKeyType"                     , "@173"   } )
   AAdd( aEntry, { "AdsGetLastAutoinc"                 , "@336"   } )
   AAdd( aEntry, { "AdsGetLastError"                   , "@74"    } )
   AAdd( aEntry, { "AdsGetLastTableUpdate"             , "@203"   } )
   AAdd( aEntry, { "AdsGetLibraryVersion"              , "@241"   } )
   AAdd( aEntry, { "AdsGetLogical"                     , "@75"    } )
   AAdd( aEntry, { "AdsGetLong"                        , "@76"    } )
   AAdd( aEntry, { "AdsGetMemoDataType"                , "@195"   } )
   AAdd( aEntry, { "AdsGetMemoLength"                  , "@77"    } )
   AAdd( aEntry, { "AdsGetMilliseconds"                , "@250"   } )
   AAdd( aEntry, { "AdsGetNullRecord"                  , "@396"   } )
   AAdd( aEntry, { "AdsGetNumActiveLinks"              , "@179"   } )
   AAdd( aEntry, { "AdsGetNumFields"                   , "@78"    } )
   AAdd( aEntry, { "AdsGetNumIndexes"                  , "@79"    } )
   AAdd( aEntry, { "AdsGetNumLocks"                    , "@80"    } )
   AAdd( aEntry, { "AdsGetNumOpenTables"               , "@81"    } )
   AAdd( aEntry, { "AdsGetNumParams"                   , "@306"   } )
   AAdd( aEntry, { "AdsGetNumSegments"                 , "@174"   } )
   AAdd( aEntry, { "AdsGetRILookupInfo"                , "@363"   } )
   AAdd( aEntry, { "AdsGetROWIDPrefix"                 , "@387"   } )
   AAdd( aEntry, { "AdsGetRecord"                      , "@83"    } )
   AAdd( aEntry, { "AdsGetRecordCount"                 , "@84"    } )
   AAdd( aEntry, { "AdsGetRecordLength"                , "@86"    } )
   AAdd( aEntry, { "AdsGetRecordNum"                   , "@85"    } )
   AAdd( aEntry, { "AdsGetRecordPointer"               , "@175"   } )
   AAdd( aEntry, { "AdsGetRelKeyPos"                   , "@87"    } )
   AAdd( aEntry, { "AdsGetSQLStatement"                , "@347"   } )
   AAdd( aEntry, { "AdsGetSQLStatementHandle"          , "@346"   } )
   AAdd( aEntry, { "AdsGetSQLStmtParams"               , "@390"   } )
   AAdd( aEntry, { "AdsGetScope"                       , "@88"    } )
   AAdd( aEntry, { "AdsGetSearchPath"                  , "@89"    } )
   AAdd( aEntry, { "AdsGetSegmentFieldNumbers"         , "@349"   } )
   AAdd( aEntry, { "AdsGetSegmentFieldname"            , "@176"   } )
   AAdd( aEntry, { "AdsGetSegmentOffset"               , "@177"   } )
   AAdd( aEntry, { "AdsGetServerName"                  , "@90"    } )
   AAdd( aEntry, { "AdsGetServerTime"                  , "@295"   } )
   AAdd( aEntry, { "AdsGetShort"                       , "@247"   } )
   AAdd( aEntry, { "AdsGetString"                      , "@91"    } )
   AAdd( aEntry, { "AdsGetTableAlias"                  , "@92"    } )
   AAdd( aEntry, { "AdsGetTableCharType"               , "@93"    } )
   AAdd( aEntry, { "AdsGetTableConnection"             , "@208"   } )
   AAdd( aEntry, { "AdsGetTableFilename"               , "@94"    } )
   AAdd( aEntry, { "AdsGetTableHandle"                 , "@95"    } )
   AAdd( aEntry, { "AdsGetTableHandle25"               , "@275"   } )
   AAdd( aEntry, { "AdsGetTableLockType"               , "@96"    } )
   AAdd( aEntry, { "AdsGetTableMemoSize"               , "@97"    } )
   AAdd( aEntry, { "AdsGetTableOpenOptions"            , "@98"    } )
   AAdd( aEntry, { "AdsGetTableRights"                 , "@99"    } )
   AAdd( aEntry, { "AdsGetTableType"                   , "@100"   } )
   AAdd( aEntry, { "AdsGetTime"                        , "@245"   } )
   AAdd( aEntry, { "AdsGetVersion"                     , "@101"   } )
   AAdd( aEntry, { "AdsGotoBookmark"                   , "@102"   } )
   AAdd( aEntry, { "AdsGotoBookmark60"                 , "@375"   } )
   AAdd( aEntry, { "AdsGotoBottom"                     , "@103"   } )
   AAdd( aEntry, { "AdsGotoRecord"                     , "@104"   } )
   AAdd( aEntry, { "AdsGotoTop"                        , "@105"   } )
   AAdd( aEntry, { "AdsImageToClipboard"               , "@200"   } )
   AAdd( aEntry, { "AdsImageToHBitmap"                 , "@199"   } )
   AAdd( aEntry, { "AdsInTransaction"                  , "@106"   } )
   AAdd( aEntry, { "AdsInitRawKey"                     , "@252"   } )
   AAdd( aEntry, { "AdsIsEmpty"                        , "@107"   } )
   AAdd( aEntry, { "AdsIsEncryptionEnabled"            , "@283"   } )
   AAdd( aEntry, { "AdsIsExprValid"                    , "@108"   } )
   AAdd( aEntry, { "AdsIsFound"                        , "@110"   } )
   AAdd( aEntry, { "AdsIsIndexCompound"                , "@111"   } )
   AAdd( aEntry, { "AdsIsIndexCustom"                  , "@112"   } )
   AAdd( aEntry, { "AdsIsIndexDescending"              , "@113"   } )
   AAdd( aEntry, { "AdsIsIndexExprValid"               , "@296"   } )
   AAdd( aEntry, { "AdsIsIndexUnique"                  , "@114"   } )
   AAdd( aEntry, { "AdsIsIndexUserDefined"             , "@300"   } )
   AAdd( aEntry, { "AdsIsRecordDeleted"                , "@190"   } )
   AAdd( aEntry, { "AdsIsRecordEncrypted"              , "@115"   } )
   AAdd( aEntry, { "AdsIsRecordInAOF"                  , "@238"   } )
   AAdd( aEntry, { "AdsIsRecordLocked"                 , "@116"   } )
   AAdd( aEntry, { "AdsIsRecordVisible"                , "@285"   } )
   AAdd( aEntry, { "AdsIsSegmentDescending"            , "@259"   } )
   AAdd( aEntry, { "AdsIsServerLoaded"                 , "@117"   } )
   AAdd( aEntry, { "AdsIsTableEncrypted"               , "@118"   } )
   AAdd( aEntry, { "AdsIsTableLocked"                  , "@119"   } )
   AAdd( aEntry, { "AdsLocate"                         , "@120"   } )
   AAdd( aEntry, { "AdsLockRecord"                     , "@121"   } )
   AAdd( aEntry, { "AdsLockRecordImplicitly"           , "@330"   } )
   AAdd( aEntry, { "AdsLockTable"                      , "@122"   } )
   AAdd( aEntry, { "AdsLookupKey"                      , "@251"   } )
   AAdd( aEntry, { "AdsMemCompare"                     , "@180"   } )
   AAdd( aEntry, { "AdsMergeAOF"                       , "@325"   } )
   AAdd( aEntry, { "AdsMgConnect"                      , "@239"   } )
   AAdd( aEntry, { "AdsMgDisconnect"                   , "@240"   } )
   AAdd( aEntry, { "AdsMgDumpInternalTables"           , "@229"   } )
   AAdd( aEntry, { "AdsMgGetActivityInfo"              , "@226"   } )
   AAdd( aEntry, { "AdsMgGetCommStats"                 , "@224"   } )
   AAdd( aEntry, { "AdsMgGetConfigInfo"                , "@225"   } )
   AAdd( aEntry, { "AdsMgGetInstallInfo"               , "@227"   } )
   AAdd( aEntry, { "AdsMgGetLockOwner"                 , "@237"   } )
   AAdd( aEntry, { "AdsMgGetLocks"                     , "@233"   } )
   AAdd( aEntry, { "AdsMgGetOpenIndexes"               , "@232"   } )
   AAdd( aEntry, { "AdsMgGetOpenTables"                , "@231"   } )
   AAdd( aEntry, { "AdsMgGetServerType"                , "@234"   } )
   AAdd( aEntry, { "AdsMgGetUserNames"                 , "@230"   } )
   AAdd( aEntry, { "AdsMgGetWorkerThreadActivity"      , "@236"   } )
   AAdd( aEntry, { "AdsMgKillUser"                     , "@235"   } )
   AAdd( aEntry, { "AdsMgResetCommStats"               , "@228"   } )
   AAdd( aEntry, { "AdsNullTerminateStrings"           , "@191"   } )
   AAdd( aEntry, { "AdsOpenIndex"                      , "@123"   } )
   AAdd( aEntry, { "AdsOpenTable"                      , "@124"   } )
   AAdd( aEntry, { "AdsPackTable"                      , "@125"   } )
   AAdd( aEntry, { "AdsParseExpr"                      , "@286"   } )
   AAdd( aEntry, { "AdsPerformRI"                      , "@290"   } )
   AAdd( aEntry, { "AdsPrepareSQL"                     , "@267"   } )
   AAdd( aEntry, { "AdsPrepareSQLNow"                  , "@305"   } )
   AAdd( aEntry, { "AdsReadRecordNumbers"              , "@324"   } )
   AAdd( aEntry, { "AdsReadRecords"                    , "@323"   } )
   AAdd( aEntry, { "AdsRecallRecord"                   , "@126"   } )
   AAdd( aEntry, { "AdsRefreshAOF"                     , "@219"   } )
   AAdd( aEntry, { "AdsRefreshRecord"                  , "@197"   } )
   AAdd( aEntry, { "AdsRefreshView"                    , "@348"   } )
   AAdd( aEntry, { "AdsRegisterCallbackFunction"       , "@388"   } )
   AAdd( aEntry, { "AdsRegisterProgressCallback"       , "@127"   } )
   AAdd( aEntry, { "AdsRegisterSQLAbortFunc"           , "@297"   } )
   AAdd( aEntry, { "AdsRegisterUDF"                    , "@301"   } )
   AAdd( aEntry, { "AdsReindex"                        , "@128"   } )
   AAdd( aEntry, { "AdsReindex61"                      , "@381"   } )
   AAdd( aEntry, { "AdsRemoveSQLComments"              , "@408"   } )
   AAdd( aEntry, { "AdsRestructureTable"               , "@322"   } )
   AAdd( aEntry, { "AdsRollbackTransaction"            , "@129"   } )
   AAdd( aEntry, { "AdsSeek"                           , "@130"   } )
   AAdd( aEntry, { "AdsSeekLast"                       , "@131"   } )
   AAdd( aEntry, { "AdsSetAOF"                         , "@216"   } )
   AAdd( aEntry, { "AdsSetBOFFlag"                     , "@211"   } )
   AAdd( aEntry, { "AdsSetBaseTableAccess"             , "@391"   } )
   AAdd( aEntry, { "AdsSetBinary"                      , "@132"   } )
   AAdd( aEntry, { "AdsSetCollationLang"               , "@133"   } )
   AAdd( aEntry, { "AdsSetCollationSequence"           , "@185"   } )
   AAdd( aEntry, { "AdsSetCursorAOF"                   , "@277"   } )
   AAdd( aEntry, { "AdsSetDate"                        , "@134"   } )
   AAdd( aEntry, { "AdsSetDateFormat"                  , "@135"   } )
   AAdd( aEntry, { "AdsSetDateFormat60"                , "@377"   } )
   AAdd( aEntry, { "AdsSetDecimals"                    , "@136"   } )
   AAdd( aEntry, { "AdsSetDefault"                     , "@137"   } )
   AAdd( aEntry, { "AdsSetDouble"                      , "@138"   } )
   AAdd( aEntry, { "AdsSetEmpty"                       , "@139"   } )
   AAdd( aEntry, { "AdsSetEpoch"                       , "@140"   } )
   AAdd( aEntry, { "AdsSetExact"                       , "@141"   } )
   AAdd( aEntry, { "AdsSetExact22"                     , "@254"   } )
   AAdd( aEntry, { "AdsSetField"                       , "@142"   } )
   AAdd( aEntry, { "AdsSetFieldRaw"                    , "@206"   } )
   AAdd( aEntry, { "AdsSetFilter"                      , "@143"   } )
   AAdd( aEntry, { "AdsSetFlushFlag"                   , "@362"   } )
   AAdd( aEntry, { "AdsSetHandleLong"                  , "@144"   } )
   AAdd( aEntry, { "AdsSetInternalError"               , "@192"   } )
   AAdd( aEntry, { "AdsSetJulian"                      , "@193"   } )
   AAdd( aEntry, { "AdsSetLastError"                   , "@194"   } )
   AAdd( aEntry, { "AdsSetLogical"                     , "@145"   } )
   AAdd( aEntry, { "AdsSetLong"                        , "@146"   } )
   AAdd( aEntry, { "AdsSetMilliseconds"                , "@249"   } )
   AAdd( aEntry, { "AdsSetPacketSize"                  , "@364"   } )
   AAdd( aEntry, { "AdsSetProperty"                    , "@400"   } )
   AAdd( aEntry, { "AdsSetRecord"                      , "@149"   } )
   AAdd( aEntry, { "AdsSetRelKeyPos"                   , "@151"   } )
   AAdd( aEntry, { "AdsSetRelation"                    , "@150"   } )
   AAdd( aEntry, { "AdsSetScope"                       , "@152"   } )
   AAdd( aEntry, { "AdsSetScopedRelation"              , "@153"   } )
   AAdd( aEntry, { "AdsSetSearchPath"                  , "@154"   } )
   AAdd( aEntry, { "AdsSetServerType"                  , "@201"   } )
   AAdd( aEntry, { "AdsSetShort"                       , "@246"   } )
   AAdd( aEntry, { "AdsSetString"                      , "@155"   } )
   AAdd( aEntry, { "AdsSetTableCharType"               , "@198"   } )
   AAdd( aEntry, { "AdsSetTime"                        , "@244"   } )
   AAdd( aEntry, { "AdsSetTimeStamp"                   , "@268"   } )
   AAdd( aEntry, { "AdsSetTimeStampRaw"                , "@276"   } )
   AAdd( aEntry, { "AdsSetupRI"                        , "@327"   } )
   AAdd( aEntry, { "AdsShowDeleted"                    , "@156"   } )
   AAdd( aEntry, { "AdsShowError"                      , "@157"   } )
   AAdd( aEntry, { "AdsSkip"                           , "@158"   } )
   AAdd( aEntry, { "AdsSqlPeekStatement"               , "@299"   } )
   AAdd( aEntry, { "AdsStepIndexKey"                   , "@303"   } )
   AAdd( aEntry, { "AdsStmtClearTablePasswords"        , "@294"   } )
   AAdd( aEntry, { "AdsStmtConstrainUpdates"           , "@280"   } )
   AAdd( aEntry, { "AdsStmtDisableEncryption"          , "@292"   } )
   AAdd( aEntry, { "AdsStmtEnableEncryption"           , "@291"   } )
   AAdd( aEntry, { "AdsStmtReadAllColumns"             , "@383"   } )
   AAdd( aEntry, { "AdsStmtSetOptimization"            , "@304"   } )
   AAdd( aEntry, { "AdsStmtSetTableCharType"           , "@269"   } )
   AAdd( aEntry, { "AdsStmtSetTableLockType"           , "@270"   } )
   AAdd( aEntry, { "AdsStmtSetTablePassword"           , "@293"   } )
   AAdd( aEntry, { "AdsStmtSetTableReadOnly"           , "@271"   } )
   AAdd( aEntry, { "AdsStmtSetTableRights"             , "@272"   } )
   AAdd( aEntry, { "AdsStmtSetTableType"               , "@273"   } )
   AAdd( aEntry, { "AdsThreadExit"                     , "@159"   } )
   AAdd( aEntry, { "AdsUnlockRecord"                   , "@160"   } )
   AAdd( aEntry, { "AdsUnlockTable"                    , "@161"   } )
   AAdd( aEntry, { "AdsVerifyPassword"                 , "@214"   } )
   AAdd( aEntry, { "AdsVerifyRI"                       , "@365"   } )
   AAdd( aEntry, { "AdsVerifySQL"                      , "@401"   } )
   AAdd( aEntry, { "AdsWriteAllRecords"                , "@162"   } )
   AAdd( aEntry, { "AdsWriteRecord"                    , "@163"   } )
   AAdd( aEntry, { "AdsZapTable"                       , "@164"   } )
   AAdd( aEntry, { "ObsAdsDecryptBuffer"               , "@213"   } )
   AAdd( aEntry, { "ObsAdsEncryptBuffer"               , "@212"   } )

   RETURN aEntry

//----------------------------------------------------------------------------//
STATIC FUNCTION DLLACE_70()

   /*
   This ordinal table is based on ace32.dll version 7.0.0.5
   This table should be updated when using other version of ace32.dll
   It will be much better to create a new sub-function, say DLLACE_nn for
   a new version rather than overwriting this function.
   */

   LOCAL aEntry := {}

   AAdd( aEntry, { "AdsActivateAOF"                 , "@220" } )
   AAdd( aEntry, { "AdsAddCustomKey"                , "@1"   } )
   AAdd( aEntry, { "AdsAddToAOF"                    , "@366" } )
   AAdd( aEntry, { "AdsAppendRecord"                , "@2"   } )
   AAdd( aEntry, { "AdsApplicationExit"             , "@3"   } )
   AAdd( aEntry, { "AdsAtBOF"                       , "@4"   } )
   AAdd( aEntry, { "AdsAtEOF"                       , "@5"   } )
   AAdd( aEntry, { "AdsBeginTransaction"            , "@6"   } )
   AAdd( aEntry, { "AdsBinaryToFile"                , "@7"   } )
   AAdd( aEntry, { "AdsBuildKeyFromRecord"          , "@166" } )
   AAdd( aEntry, { "AdsBuildRawKey"                 , "@253" } )
   AAdd( aEntry, { "AdsCacheOpenCursors"            , "@279" } )
   AAdd( aEntry, { "AdsCacheOpenTables"             , "@8"   } )
   AAdd( aEntry, { "AdsCacheRecords"                , "@242" } )
   AAdd( aEntry, { "AdsCancelUpdate"                , "@196" } )
   AAdd( aEntry, { "AdsCheckExistence"              , "@167" } )
   AAdd( aEntry, { "AdsClearAOF"                    , "@218" } )
   AAdd( aEntry, { "AdsClearAllScopes"              , "@9"   } )
   AAdd( aEntry, { "AdsClearCallbackFunction"       , "@389" } )
   AAdd( aEntry, { "AdsClearCursorAOF"              , "@278" } )
   AAdd( aEntry, { "AdsClearDefault"                , "@205" } )
   AAdd( aEntry, { "AdsClearFilter"                 , "@10"  } )
   AAdd( aEntry, { "AdsClearLastError"              , "@186" } )
   AAdd( aEntry, { "AdsClearProgressCallback"       , "@13"  } )
   AAdd( aEntry, { "AdsClearRecordBuffer"           , "@284" } )
   AAdd( aEntry, { "AdsClearRelation"               , "@14"  } )
   AAdd( aEntry, { "AdsClearSQLAbortFunc"           , "@298" } )
   AAdd( aEntry, { "AdsClearSQLParams"              , "@274" } )
   AAdd( aEntry, { "AdsClearScope"                  , "@15"  } )
   AAdd( aEntry, { "AdsCloneTable"                  , "@210" } )
   AAdd( aEntry, { "AdsCloseAllIndexes"             , "@16"  } )
   AAdd( aEntry, { "AdsCloseAllTables"              , "@17"  } )
   AAdd( aEntry, { "AdsCloseCachedTables"           , "@438" } )
   AAdd( aEntry, { "AdsCloseIndex"                  , "@18"  } )
   AAdd( aEntry, { "AdsCloseSQLStatement"           , "@262" } )
   AAdd( aEntry, { "AdsCloseTable"                  , "@19"  } )
   AAdd( aEntry, { "AdsCommitTransaction"           , "@20"  } )
   AAdd( aEntry, { "AdsCompareBookmarks"            , "@374" } )
   AAdd( aEntry, { "AdsConnect"                     , "@21"  } )
   AAdd( aEntry, { "AdsConnect26"                   , "@302" } )
   AAdd( aEntry, { "AdsConnect60"                   , "@315" } )
   AAdd( aEntry, { "AdsContinue"                    , "@22"  } )
   AAdd( aEntry, { "AdsConvertDateToJulian"         , "@437" } )
   AAdd( aEntry, { "AdsConvertJulianToString"       , "@184" } )
   AAdd( aEntry, { "AdsConvertKeyToDouble"          , "@168" } )
   AAdd( aEntry, { "AdsConvertMillisecondsToString" , "@261" } )
   AAdd( aEntry, { "AdsConvertStringToJulian"       , "@183" } )
   AAdd( aEntry, { "AdsConvertStringToMilliseconds" , "@260" } )
   AAdd( aEntry, { "AdsConvertTable"                , "@248" } )
   AAdd( aEntry, { "AdsCopyTable"                   , "@23"  } )
   AAdd( aEntry, { "AdsCopyTableContents"           , "@24"  } )
   AAdd( aEntry, { "AdsCopyTableStructure"          , "@25"  } )
   AAdd( aEntry, { "AdsCopyTableTop"                , "@395" } )
   AAdd( aEntry, { "AdsCreateFTSIndex"              , "@419" } )
   AAdd( aEntry, { "AdsCreateIndex"                 , "@26"  } )
   AAdd( aEntry, { "AdsCreateIndex61"               , "@380" } )
   AAdd( aEntry, { "AdsCreateMemTable"              , "@431" } )
   AAdd( aEntry, { "AdsCreateSQLStatement"          , "@263" } )
   AAdd( aEntry, { "AdsCreateTable"                 , "@27"  } )
   AAdd( aEntry, { "AdsCustomizeAOF"                , "@258" } )
   AAdd( aEntry, { "AdsDBFDateToString"             , "@215" } )
   AAdd( aEntry, { "AdsDDAddIndexFile"              , "@333" } )
   AAdd( aEntry, { "AdsDDAddProcedure"              , "@356" } )
   AAdd( aEntry, { "AdsDDAddTable"                  , "@313" } )
   AAdd( aEntry, { "AdsDDAddUserToGroup"            , "@351" } )
   AAdd( aEntry, { "AdsDDAddView"                   , "@340" } )
   AAdd( aEntry, { "AdsDDAutoCreateIndex"           , "@385" } )
   AAdd( aEntry, { "AdsDDAutoCreateTable"           , "@384" } )
   AAdd( aEntry, { "AdsDDClose"                     , "@309" } )
   AAdd( aEntry, { "AdsDDCreate"                    , "@308" } )
   AAdd( aEntry, { "AdsDDCreateASA"                 , "@424" } )
   AAdd( aEntry, { "AdsDDCreateLink"                , "@181" } )
   AAdd( aEntry, { "AdsDDCreateRefIntegrity"        , "@318" } )
   AAdd( aEntry, { "AdsDDCreateRefIntegrity62"      , "@397" } )
   AAdd( aEntry, { "AdsDDCreateTrigger"             , "@411" } )
   AAdd( aEntry, { "AdsDDCreateUser"                , "@350" } )
   AAdd( aEntry, { "AdsDDCreateUserGroup"           , "@354" } )
   AAdd( aEntry, { "AdsDDDeleteIndex"               , "@339" } )
   AAdd( aEntry, { "AdsDDDeleteUser"                , "@352" } )
   AAdd( aEntry, { "AdsDDDeleteUserGroup"           , "@355" } )
   AAdd( aEntry, { "AdsDDDeployDatabase"            , "@379" } )
   AAdd( aEntry, { "AdsDDDropLink"                  , "@182" } )
   AAdd( aEntry, { "AdsDDExecuteProcedure"          , "@359" } )
   AAdd( aEntry, { "AdsDDFindClose"                 , "@321" } )
   AAdd( aEntry, { "AdsDDFindFirstObject"           , "@319" } )
   AAdd( aEntry, { "AdsDDFindNextObject"            , "@320" } )
   AAdd( aEntry, { "AdsDDGetDatabaseProperty"       , "@311" } )
   AAdd( aEntry, { "AdsDDGetFieldProperty"          , "@332" } )
   AAdd( aEntry, { "AdsDDGetIndexFileProperty"      , "@335" } )
   AAdd( aEntry, { "AdsDDGetIndexProperty"          , "@360" } )
   AAdd( aEntry, { "AdsDDGetLinkProperty"           , "@399" } )
   AAdd( aEntry, { "AdsDDGetPermissions"            , "@392" } )
   AAdd( aEntry, { "AdsDDGetProcedureProperty"      , "@358" } )
   AAdd( aEntry, { "AdsDDGetRefIntegrityProperty"   , "@337" } )
   AAdd( aEntry, { "AdsDDGetTableOpenOptions"       , "@369" } )
   AAdd( aEntry, { "AdsDDGetTableProperty"          , "@316" } )
   AAdd( aEntry, { "AdsDDGetTriggerProperty"        , "@413" } )
   AAdd( aEntry, { "AdsDDGetUserGroupProperty"      , "@370" } )
   AAdd( aEntry, { "AdsDDGetUserProperty"           , "@361" } )
   AAdd( aEntry, { "AdsDDGetViewProperty"           , "@342" } )
   AAdd( aEntry, { "AdsDDGrantPermission"           , "@393" } )
   AAdd( aEntry, { "AdsDDOpen"                      , "@310" } )
   AAdd( aEntry, { "AdsDDRemoveIndexFile"           , "@338" } )
   AAdd( aEntry, { "AdsDDRemoveProcedure"           , "@357" } )
   AAdd( aEntry, { "AdsDDRemoveRefIntegrity"        , "@334" } )
   AAdd( aEntry, { "AdsDDRemoveTable"               , "@314" } )
   AAdd( aEntry, { "AdsDDRemoveTrigger"             , "@412" } )
   AAdd( aEntry, { "AdsDDRemoveUserFromGroup"       , "@353" } )
   AAdd( aEntry, { "AdsDDRemoveView"                , "@341" } )
   AAdd( aEntry, { "AdsDDRevokePermission"          , "@394" } )
   AAdd( aEntry, { "AdsDDSetDatabaseProperty"       , "@312" } )
   AAdd( aEntry, { "AdsDDSetFieldProperty"          , "@331" } )
   AAdd( aEntry, { "AdsDDSetObjectAccessRights"     , "@368" } )
   AAdd( aEntry, { "AdsDDSetTableProperty"          , "@317" } )
   AAdd( aEntry, { "AdsDDSetUserGroupProperty"      , "@371" } )
   AAdd( aEntry, { "AdsDDSetUserProperty"           , "@367" } )
   AAdd( aEntry, { "AdsDDVerifyUserRights"          , "@376" } )
   AAdd( aEntry, { "AdsDeactivateAOF"               , "@221" } )
   AAdd( aEntry, { "AdsDecryptRecord"               , "@282" } )
   AAdd( aEntry, { "AdsDecryptTable"                , "@28"  } )
   AAdd( aEntry, { "AdsDeleteCustomKey"             , "@29"  } )
   AAdd( aEntry, { "AdsDeleteFile"                  , "@187" } )
   AAdd( aEntry, { "AdsDeleteIndex"                 , "@30"  } )
   AAdd( aEntry, { "AdsDeleteRecord"                , "@31"  } )
   AAdd( aEntry, { "AdsDeleteTable"                 , "@169" } )
   AAdd( aEntry, { "AdsDisableAutoIncEnforcement"   , "@410" } )
   AAdd( aEntry, { "AdsDisableEncryption"           , "@12"  } )
   AAdd( aEntry, { "AdsDisableLocalConnections"     , "@329" } )
   AAdd( aEntry, { "AdsDisableRI"                   , "@407" } )
   AAdd( aEntry, { "AdsDisableUniqueEnforcement"    , "@405" } )
   AAdd( aEntry, { "AdsDisconnect"                  , "@32"  } )
   AAdd( aEntry, { "AdsEcho"                        , "@307" } )
   AAdd( aEntry, { "AdsEnableAutoIncEnforcement"    , "@409" } )
   AAdd( aEntry, { "AdsEnableEncryption"            , "@148" } )
   AAdd( aEntry, { "AdsEnableRI"                    , "@406" } )
   AAdd( aEntry, { "AdsEnableUniqueEnforcement"     , "@404" } )
   AAdd( aEntry, { "AdsEncryptRecord"               , "@281" } )
   AAdd( aEntry, { "AdsEncryptTable"                , "@33"  } )
   AAdd( aEntry, { "AdsEvalAOF"                     , "@217" } )
   AAdd( aEntry, { "AdsEvalExpr"                    , "@287" } )
   AAdd( aEntry, { "AdsEvalLogicalExpr"             , "@34"  } )
   AAdd( aEntry, { "AdsEvalNumericExpr"             , "@35"  } )
   AAdd( aEntry, { "AdsEvalStringExpr"              , "@36"  } )
   AAdd( aEntry, { "AdsEvalTestExpr"                , "@37"  } )
   AAdd( aEntry, { "AdsExecuteSQL"                  , "@264" } )
   AAdd( aEntry, { "AdsExecuteSQLDirect"            , "@265" } )
   AAdd( aEntry, { "AdsExpressionLongToShort"       , "@256" } )
   AAdd( aEntry, { "AdsExpressionShortToLong"       , "@257" } )
   AAdd( aEntry, { "AdsExtractKey"                  , "@38"  } )
   AAdd( aEntry, { "AdsExtractPathPart"             , "@243" } )
   AAdd( aEntry, { "AdsFailedTransactionRecovery"   , "@39"  } )
   AAdd( aEntry, { "AdsFileToBinary"                , "@40"  } )
   AAdd( aEntry, { "AdsFindClose"                   , "@170" } )
   AAdd( aEntry, { "AdsFindConnection"              , "@41"  } )
   AAdd( aEntry, { "AdsFindConnection25"            , "@289" } )
   AAdd( aEntry, { "AdsFindFirstTable"              , "@171" } )
   AAdd( aEntry, { "AdsFindFirstTable62"            , "@402" } )
   AAdd( aEntry, { "AdsFindNextTable"               , "@172" } )
   AAdd( aEntry, { "AdsFindNextTable62"             , "@403" } )
   AAdd( aEntry, { "AdsFlushFileBuffers"            , "@378" } )
   AAdd( aEntry, { "AdsFreeExpr"                    , "@288" } )
   AAdd( aEntry, { "AdsFreeTokenBuffer"             , "@427" } )
   AAdd( aEntry, { "AdsGetAOF"                      , "@222" } )
   AAdd( aEntry, { "AdsGetAOFOptLevel"              , "@223" } )
   AAdd( aEntry, { "AdsGetActiveLinkInfo"           , "@398" } )
   AAdd( aEntry, { "AdsGetAllIndexes"               , "@42"  } )
   AAdd( aEntry, { "AdsGetAllLocks"                 , "@43"  } )
   AAdd( aEntry, { "AdsGetAllTables"                , "@44"  } )
   AAdd( aEntry, { "AdsGetBaseFieldName"            , "@344" } )
   AAdd( aEntry, { "AdsGetBaseFieldNum"             , "@343" } )
   AAdd( aEntry, { "AdsGetBinary"                   , "@45"  } )
   AAdd( aEntry, { "AdsGetBinaryLength"             , "@46"  } )
   AAdd( aEntry, { "AdsGetBookmark"                 , "@47"  } )
   AAdd( aEntry, { "AdsGetBookmark60"               , "@372" } )
   AAdd( aEntry, { "AdsGetBookmarkLength"           , "@373" } )
   AAdd( aEntry, { "AdsGetCollationLang"            , "@48"  } )
   AAdd( aEntry, { "AdsGetColumnPermissions"        , "@165" } )
   AAdd( aEntry, { "AdsGetConnectionPath"           , "@423" } )
   AAdd( aEntry, { "AdsGetConnectionProperty"       , "@439" } )
   AAdd( aEntry, { "AdsGetConnectionType"           , "@209" } )
   AAdd( aEntry, { "AdsGetCursorAOF"                , "@345" } )
   AAdd( aEntry, { "AdsGetDate"                     , "@49"  } )
   AAdd( aEntry, { "AdsGetDateFormat"               , "@50"  } )
   AAdd( aEntry, { "AdsGetDateFormat60"             , "@386" } )
   AAdd( aEntry, { "AdsGetDecimals"                 , "@51"  } )
   AAdd( aEntry, { "AdsGetDefault"                  , "@52"  } )
   AAdd( aEntry, { "AdsGetDeleted"                  , "@53"  } )
   AAdd( aEntry, { "AdsGetDouble"                   , "@54"  } )
   AAdd( aEntry, { "AdsGetEpoch"                    , "@55"  } )
   AAdd( aEntry, { "AdsGetErrorString"              , "@56"  } )
   AAdd( aEntry, { "AdsGetExact"                    , "@57"  } )
   AAdd( aEntry, { "AdsGetExact22"                  , "@255" } )
   AAdd( aEntry, { "AdsGetFTSIndexInfo"             , "@428" } )
   AAdd( aEntry, { "AdsGetFTSIndexes"               , "@422" } )
   AAdd( aEntry, { "AdsGetFTSScore"                 , "@432" } )
   AAdd( aEntry, { "AdsGetField"                    , "@58"  } )
   AAdd( aEntry, { "AdsGetFieldDecimals"            , "@59"  } )
   AAdd( aEntry, { "AdsGetFieldLength"              , "@60"  } )
   AAdd( aEntry, { "AdsGetFieldName"                , "@61"  } )
   AAdd( aEntry, { "AdsGetFieldNum"                 , "@62"  } )
   AAdd( aEntry, { "AdsGetFieldOffset"              , "@63"  } )
   AAdd( aEntry, { "AdsGetFieldRaw"                 , "@328" } )
   AAdd( aEntry, { "AdsGetFieldType"                , "@64"  } )
   AAdd( aEntry, { "AdsGetFilter"                   , "@65"  } )
   AAdd( aEntry, { "AdsGetHandleLong"               , "@66"  } )
   AAdd( aEntry, { "AdsGetHandleType"               , "@202" } )
   AAdd( aEntry, { "AdsGetIndexCondition"           , "@67"  } )
   AAdd( aEntry, { "AdsGetIndexExpr"                , "@68"  } )
   AAdd( aEntry, { "AdsGetIndexFilename"            , "@69"  } )
   AAdd( aEntry, { "AdsGetIndexFlags"               , "@178" } )
   AAdd( aEntry, { "AdsGetIndexHandle"              , "@70"  } )
   AAdd( aEntry, { "AdsGetIndexHandleByExpr"        , "@266" } )
   AAdd( aEntry, { "AdsGetIndexHandleByOrder"       , "@204" } )
   AAdd( aEntry, { "AdsGetIndexName"                , "@71"  } )
   AAdd( aEntry, { "AdsGetIndexOrderByHandle"       , "@207" } )
   AAdd( aEntry, { "AdsGetIndexPageSize"            , "@382" } )
   AAdd( aEntry, { "AdsGetJulian"                   , "@188" } )
   AAdd( aEntry, { "AdsGetKeyColumn"                , "@433" } )
   AAdd( aEntry, { "AdsGetKeyCount"                 , "@72"  } )
   AAdd( aEntry, { "AdsGetKeyLength"                , "@189" } )
   AAdd( aEntry, { "AdsGetKeyNum"                   , "@73"  } )
   AAdd( aEntry, { "AdsGetKeyType"                  , "@173" } )
   AAdd( aEntry, { "AdsGetLastAutoinc"              , "@336" } )
   AAdd( aEntry, { "AdsGetLastError"                , "@74"  } )
   AAdd( aEntry, { "AdsGetLastTableUpdate"          , "@203" } )
   AAdd( aEntry, { "AdsGetLibraryVersion"           , "@241" } )
   AAdd( aEntry, { "AdsGetLogical"                  , "@75"  } )
   AAdd( aEntry, { "AdsGetLong"                     , "@76"  } )
   AAdd( aEntry, { "AdsGetLongLong"                 , "@418" } )
   AAdd( aEntry, { "AdsGetMemoDataType"             , "@195" } )
   AAdd( aEntry, { "AdsGetMemoLength"               , "@77"  } )
   AAdd( aEntry, { "AdsGetMilliseconds"             , "@250" } )
   AAdd( aEntry, { "AdsGetMoney"                    , "@415" } )
   AAdd( aEntry, { "AdsGetNullRecord"               , "@396" } )
   AAdd( aEntry, { "AdsGetNumActiveLinks"           , "@179" } )
   AAdd( aEntry, { "AdsGetNumFTSIndexes"            , "@421" } )
   AAdd( aEntry, { "AdsGetNumFields"                , "@78"  } )
   AAdd( aEntry, { "AdsGetNumIndexes"               , "@79"  } )
   AAdd( aEntry, { "AdsGetNumLocks"                 , "@80"  } )
   AAdd( aEntry, { "AdsGetNumOpenTables"            , "@81"  } )
   AAdd( aEntry, { "AdsGetNumParams"                , "@306" } )
   AAdd( aEntry, { "AdsGetNumSegments"              , "@174" } )
   AAdd( aEntry, { "AdsGetRILookupInfo"             , "@363" } )
   AAdd( aEntry, { "AdsGetROWIDPrefix"              , "@387" } )
   AAdd( aEntry, { "AdsGetRecord"                   , "@83"  } )
   AAdd( aEntry, { "AdsGetRecordCount"              , "@84"  } )
   AAdd( aEntry, { "AdsGetRecordLength"             , "@86"  } )
   AAdd( aEntry, { "AdsGetRecordNum"                , "@85"  } )
   AAdd( aEntry, { "AdsGetRecordPointer"            , "@175" } )
   AAdd( aEntry, { "AdsGetRelKeyPos"                , "@87"  } )
   AAdd( aEntry, { "AdsGetSQLStatement"             , "@347" } )
   AAdd( aEntry, { "AdsGetSQLStatementHandle"       , "@346" } )
   AAdd( aEntry, { "AdsGetSQLStmtParams"            , "@390" } )
   AAdd( aEntry, { "AdsGetScope"                    , "@88"  } )
   AAdd( aEntry, { "AdsGetSearchPath"               , "@89"  } )
   AAdd( aEntry, { "AdsGetSegmentFieldNumbers"      , "@349" } )
   AAdd( aEntry, { "AdsGetSegmentFieldname"         , "@176" } )
   AAdd( aEntry, { "AdsGetSegmentOffset"            , "@177" } )
   AAdd( aEntry, { "AdsGetServerName"               , "@90"  } )
   AAdd( aEntry, { "AdsGetServerTime"               , "@295" } )
   AAdd( aEntry, { "AdsGetShort"                    , "@247" } )
   AAdd( aEntry, { "AdsGetString"                   , "@91"  } )
   AAdd( aEntry, { "AdsGetTableAlias"               , "@92"  } )
   AAdd( aEntry, { "AdsGetTableCharType"            , "@93"  } )
   AAdd( aEntry, { "AdsGetTableConnection"          , "@208" } )
   AAdd( aEntry, { "AdsGetTableFilename"            , "@94"  } )
   AAdd( aEntry, { "AdsGetTableHandle"              , "@95"  } )
   AAdd( aEntry, { "AdsGetTableHandle25"            , "@275" } )
   AAdd( aEntry, { "AdsGetTableLockType"            , "@96"  } )
   AAdd( aEntry, { "AdsGetTableMemoSize"            , "@97"  } )
   AAdd( aEntry, { "AdsGetTableOpenOptions"         , "@98"  } )
   AAdd( aEntry, { "AdsGetTableRights"              , "@99"  } )
   AAdd( aEntry, { "AdsGetTableType"                , "@100" } )
   AAdd( aEntry, { "AdsGetTableWAN"                 , "@429" } )
   AAdd( aEntry, { "AdsGetTime"                     , "@245" } )
   AAdd( aEntry, { "AdsGetVersion"                  , "@101" } )
   AAdd( aEntry, { "AdsGotoBOF"                     , "@414" } )
   AAdd( aEntry, { "AdsGotoBookmark"                , "@102" } )
   AAdd( aEntry, { "AdsGotoBookmark60"              , "@375" } )
   AAdd( aEntry, { "AdsGotoBottom"                  , "@103" } )
   AAdd( aEntry, { "AdsGotoRecord"                  , "@104" } )
   AAdd( aEntry, { "AdsGotoTop"                     , "@105" } )
   AAdd( aEntry, { "AdsImageToClipboard"            , "@200" } )
   AAdd( aEntry, { "AdsImageToHBitmap"              , "@199" } )
   AAdd( aEntry, { "AdsInTransaction"               , "@106" } )
   AAdd( aEntry, { "AdsInitRawKey"                  , "@252" } )
   AAdd( aEntry, { "AdsInitTokenBuffer"             , "@425" } )
   AAdd( aEntry, { "AdsIsEmpty"                     , "@107" } )
   AAdd( aEntry, { "AdsIsEncryptionEnabled"         , "@283" } )
   AAdd( aEntry, { "AdsIsExprValid"                 , "@108" } )
   AAdd( aEntry, { "AdsIsFound"                     , "@110" } )
   AAdd( aEntry, { "AdsIsIndexCompound"             , "@111" } )
   AAdd( aEntry, { "AdsIsIndexCustom"               , "@112" } )
   AAdd( aEntry, { "AdsIsIndexDescending"           , "@113" } )
   AAdd( aEntry, { "AdsIsIndexExprValid"            , "@296" } )
   AAdd( aEntry, { "AdsIsIndexFTS"                  , "@435" } )
   AAdd( aEntry, { "AdsIsIndexUnique"               , "@114" } )
   AAdd( aEntry, { "AdsIsIndexUserDefined"          , "@300" } )
   AAdd( aEntry, { "AdsIsRecordDeleted"             , "@190" } )
   AAdd( aEntry, { "AdsIsRecordEncrypted"           , "@115" } )
   AAdd( aEntry, { "AdsIsRecordInAOF"               , "@238" } )
   AAdd( aEntry, { "AdsIsRecordLocked"              , "@116" } )
   AAdd( aEntry, { "AdsIsRecordVisible"             , "@285" } )
   AAdd( aEntry, { "AdsIsSegmentDescending"         , "@259" } )
   AAdd( aEntry, { "AdsIsServerLoaded"              , "@117" } )
   AAdd( aEntry, { "AdsIsTableEncrypted"            , "@118" } )
   AAdd( aEntry, { "AdsIsTableLocked"               , "@119" } )
   AAdd( aEntry, { "AdsLocate"                      , "@120" } )
   AAdd( aEntry, { "AdsLockRecord"                  , "@121" } )
   AAdd( aEntry, { "AdsLockRecordImplicitly"        , "@330" } )
   AAdd( aEntry, { "AdsLockTable"                   , "@122" } )
   AAdd( aEntry, { "AdsLookupKey"                   , "@251" } )
   AAdd( aEntry, { "AdsMakeNameUnique"              , "@426" } )
   AAdd( aEntry, { "AdsMemCompare"                  , "@180" } )
   AAdd( aEntry, { "AdsMergeAOF"                    , "@325" } )
   AAdd( aEntry, { "AdsMgConnect"                   , "@239" } )
   AAdd( aEntry, { "AdsMgDisconnect"                , "@240" } )
   AAdd( aEntry, { "AdsMgDumpInternalTables"        , "@229" } )
   AAdd( aEntry, { "AdsMgGetActivityInfo"           , "@226" } )
   AAdd( aEntry, { "AdsMgGetCommStats"              , "@224" } )
   AAdd( aEntry, { "AdsMgGetConfigInfo"             , "@225" } )
   AAdd( aEntry, { "AdsMgGetInstallInfo"            , "@227" } )
   AAdd( aEntry, { "AdsMgGetLockOwner"              , "@237" } )
   AAdd( aEntry, { "AdsMgGetLocks"                  , "@233" } )
   AAdd( aEntry, { "AdsMgGetOpenIndexes"            , "@232" } )
   AAdd( aEntry, { "AdsMgGetOpenTables"             , "@231" } )
   AAdd( aEntry, { "AdsMgGetServerType"             , "@234" } )
   AAdd( aEntry, { "AdsMgGetUserNames"              , "@230" } )
   AAdd( aEntry, { "AdsMgGetWorkerThreadActivity"   , "@236" } )
   AAdd( aEntry, { "AdsMgKillUser"                  , "@235" } )
   AAdd( aEntry, { "AdsMgResetCommStats"            , "@228" } )
   AAdd( aEntry, { "AdsNullTerminateStrings"        , "@191" } )
   AAdd( aEntry, { "AdsOpenIndex"                   , "@123" } )
   AAdd( aEntry, { "AdsOpenTable"                   , "@124" } )
   AAdd( aEntry, { "AdsPackTable"                   , "@125" } )
   AAdd( aEntry, { "AdsParseExpr"                   , "@286" } )
   AAdd( aEntry, { "AdsPerformRI"                   , "@290" } )
   AAdd( aEntry, { "AdsPrepareSQL"                  , "@267" } )
   AAdd( aEntry, { "AdsPrepareSQLNow"               , "@305" } )
   AAdd( aEntry, { "AdsPullTrigger"                 , "@430" } )
   AAdd( aEntry, { "AdsReadRecordNumbers"           , "@324" } )
   AAdd( aEntry, { "AdsReadRecords"                 , "@323" } )
   AAdd( aEntry, { "AdsRecallAllRecords"            , "@436" } )
   AAdd( aEntry, { "AdsRecallRecord"                , "@126" } )
   AAdd( aEntry, { "AdsRefreshAOF"                  , "@219" } )
   AAdd( aEntry, { "AdsRefreshRecord"               , "@197" } )
   AAdd( aEntry, { "AdsRefreshView"                 , "@348" } )
   AAdd( aEntry, { "AdsRegisterCallbackFunction"    , "@388" } )
   AAdd( aEntry, { "AdsRegisterProgressCallback"    , "@127" } )
   AAdd( aEntry, { "AdsRegisterSQLAbortFunc"        , "@297" } )
   AAdd( aEntry, { "AdsRegisterUDF"                 , "@301" } )
   AAdd( aEntry, { "AdsReindex"                     , "@128" } )
   AAdd( aEntry, { "AdsReindex61"                   , "@381" } )
   AAdd( aEntry, { "AdsReindexFTS"                  , "@420" } )
   AAdd( aEntry, { "AdsRemoveSQLComments"           , "@408" } )
   AAdd( aEntry, { "AdsResetConnection"             , "@434" } )
   AAdd( aEntry, { "AdsRestructureTable"            , "@322" } )
   AAdd( aEntry, { "AdsRollbackTransaction"         , "@129" } )
   AAdd( aEntry, { "AdsSeek"                        , "@130" } )
   AAdd( aEntry, { "AdsSeekLast"                    , "@131" } )
   AAdd( aEntry, { "AdsSetAOF"                      , "@216" } )
   AAdd( aEntry, { "AdsSetBOFFlag"                  , "@211" } )
   AAdd( aEntry, { "AdsSetBaseTableAccess"          , "@391" } )
   AAdd( aEntry, { "AdsSetBinary"                   , "@132" } )
   AAdd( aEntry, { "AdsSetCollationLang"            , "@133" } )
   AAdd( aEntry, { "AdsSetCollationSequence"        , "@185" } )
   AAdd( aEntry, { "AdsSetCursorAOF"                , "@277" } )
   AAdd( aEntry, { "AdsSetDate"                     , "@134" } )
   AAdd( aEntry, { "AdsSetDateFormat"               , "@135" } )
   AAdd( aEntry, { "AdsSetDateFormat60"             , "@377" } )
   AAdd( aEntry, { "AdsSetDecimals"                 , "@136" } )
   AAdd( aEntry, { "AdsSetDefault"                  , "@137" } )
   AAdd( aEntry, { "AdsSetDouble"                   , "@138" } )
   AAdd( aEntry, { "AdsSetEmpty"                    , "@139" } )
   AAdd( aEntry, { "AdsSetEpoch"                    , "@140" } )
   AAdd( aEntry, { "AdsSetExact"                    , "@141" } )
   AAdd( aEntry, { "AdsSetExact22"                  , "@254" } )
   AAdd( aEntry, { "AdsSetField"                    , "@142" } )
   AAdd( aEntry, { "AdsSetFieldRaw"                 , "@206" } )
   AAdd( aEntry, { "AdsSetFilter"                   , "@143" } )
   AAdd( aEntry, { "AdsSetFlushFlag"                , "@362" } )
   AAdd( aEntry, { "AdsSetHandleLong"               , "@144" } )
   AAdd( aEntry, { "AdsSetInternalError"            , "@192" } )
   AAdd( aEntry, { "AdsSetJulian"                   , "@193" } )
   AAdd( aEntry, { "AdsSetLastError"                , "@194" } )
   AAdd( aEntry, { "AdsSetLogical"                  , "@145" } )
   AAdd( aEntry, { "AdsSetLong"                     , "@146" } )
   AAdd( aEntry, { "AdsSetLongLong"                 , "@417" } )
   AAdd( aEntry, { "AdsSetMilliseconds"             , "@249" } )
   AAdd( aEntry, { "AdsSetMoney"                    , "@416" } )
   AAdd( aEntry, { "AdsSetPacketSize"               , "@364" } )
   AAdd( aEntry, { "AdsSetProperty"                 , "@400" } )
   AAdd( aEntry, { "AdsSetRecord"                   , "@149" } )
   AAdd( aEntry, { "AdsSetRelKeyPos"                , "@151" } )
   AAdd( aEntry, { "AdsSetRelation"                 , "@150" } )
   AAdd( aEntry, { "AdsSetScope"                    , "@152" } )
   AAdd( aEntry, { "AdsSetScopedRelation"           , "@153" } )
   AAdd( aEntry, { "AdsSetSearchPath"               , "@154" } )
   AAdd( aEntry, { "AdsSetServerType"               , "@201" } )
   AAdd( aEntry, { "AdsSetShort"                    , "@246" } )
   AAdd( aEntry, { "AdsSetString"                   , "@155" } )
   AAdd( aEntry, { "AdsSetTableCharType"            , "@198" } )
   AAdd( aEntry, { "AdsSetTime"                     , "@244" } )
   AAdd( aEntry, { "AdsSetTimeStamp"                , "@268" } )
   AAdd( aEntry, { "AdsSetTimeStampRaw"             , "@276" } )
   AAdd( aEntry, { "AdsSetupRI"                     , "@327" } )
   AAdd( aEntry, { "AdsShowDeleted"                 , "@156" } )
   AAdd( aEntry, { "AdsShowError"                   , "@157" } )
   AAdd( aEntry, { "AdsSkip"                        , "@158" } )
   AAdd( aEntry, { "AdsSqlPeekStatement"            , "@299" } )
   AAdd( aEntry, { "AdsStepIndexKey"                , "@303" } )
   AAdd( aEntry, { "AdsStmtClearTablePasswords"     , "@294" } )
   AAdd( aEntry, { "AdsStmtConstrainUpdates"        , "@280" } )
   AAdd( aEntry, { "AdsStmtDisableEncryption"       , "@292" } )
   AAdd( aEntry, { "AdsStmtEnableEncryption"        , "@291" } )
   AAdd( aEntry, { "AdsStmtReadAllColumns"          , "@383" } )
   AAdd( aEntry, { "AdsStmtSetOptimization"         , "@304" } )
   AAdd( aEntry, { "AdsStmtSetTableCharType"        , "@269" } )
   AAdd( aEntry, { "AdsStmtSetTableLockType"        , "@270" } )
   AAdd( aEntry, { "AdsStmtSetTablePassword"        , "@293" } )
   AAdd( aEntry, { "AdsStmtSetTableReadOnly"        , "@271" } )
   AAdd( aEntry, { "AdsStmtSetTableRights"          , "@272" } )
   AAdd( aEntry, { "AdsStmtSetTableType"            , "@273" } )
   AAdd( aEntry, { "AdsThreadExit"                  , "@159" } )
   AAdd( aEntry, { "AdsUnlockRecord"                , "@160" } )
   AAdd( aEntry, { "AdsUnlockTable"                 , "@161" } )
   AAdd( aEntry, { "AdsVerifyPassword"              , "@214" } )
   AAdd( aEntry, { "AdsVerifyRI"                    , "@365" } )
   AAdd( aEntry, { "AdsVerifySQL"                   , "@401" } )
   AAdd( aEntry, { "AdsWriteAllRecords"             , "@162" } )
   AAdd( aEntry, { "AdsWriteRecord"                 , "@163" } )
   AAdd( aEntry, { "AdsZapTable"                    , "@164" } )
   AAdd( aEntry, { "ObsAdsDecryptBuffer"            , "@213" } )
   AAdd( aEntry, { "ObsAdsEncryptBuffer"            , "@212" } )

   RETURN aEntry

//----------------------------------------------------------------------------//
STATIC PROCEDURE View( cFile )

   LOCAL o := HBEditor():New("",1,1,maxrow()-1,maxcol()-1,.F.,maxcol()-2)
   LOCAL nkey

   dispbox(0,0,maxrow(),maxcol(),B_SINGLE + ' ')
   dispoutat( 0,1, "[ " + cFile + " ]" )

   o:lWordWrap := .F.
   o:Loadfile( cFile )

   WHILE ( ( nKey := inkey() ) != K_ESC )
      o:MoveCursor(nKey)
   ENDDO

   RETURN

//----------------------------------------------------------------------------//
STATIC FUNCTION GetLibEXE()

   LOCAL cPath := getenv( "PATH" )
   LOCAL aPath := FParseLine( cPath, ";" )
   LOCAL i, lFound := .F., cEXE := ""

   FOR i := 1 TO LEN( aPath )
      IF FILE( cEXE := aPath[i] + "\LIB386.EXE" )
         lFound := .T.
         EXIT
      ENDIF
   NEXT

   RETURN IF( lFound, cEXE, "" )

//----------------------------------------------------------------------------//
#PRAGMA BEGINDUMP
#include "hbapi.h"
#include <windows.h>
HB_FUNC_STATIC( CREATELIB )
{
   STARTUPINFO sInfo;
   PROCESS_INFORMATION pInfo;

   sInfo.cb = sizeof( sInfo );
   sInfo.dwFlags = 1;
   sInfo.wShowWindow = 0;
   CreateProcess( 0, hb_parc(1), 0, 0, FALSE, 0x00000010, 0, 0, &sInfo, &pInfo );
   WaitForSingleObject( pInfo.hProcess, 0xFFFFFFFF );
}
#PRAGMA ENDDUMP
